#!/tvbin/tivosh 

# dailymail_jazz.tcl
# e-mail TiVo status and info
#
# Original Baseline Version 0.3 (29/11/03) by Stuart Anderton (sanderton at tivocommunity.com)
#
# Some procs borrowed from TiVoWeb as you can't call them by reference, credited below
# Ta to vassilis for date fix
# Incorparates verious suggestions from the TiVo Community thread
#
# Just jazzed up a little by Chris Stennett (tivo-onion at tivocommunity.com)
# Built on baselined version 0.3 of dailymail.tcl
#
# Change Log:
# -----------
# v0.3 bug fixed where crashed when creating reboot row - where no reboot is required
# v0.5 end padding monitoring added
# v0.6 added end padding function around log file currency
# v0.7 added LJ's space, version setting and mail code (From LJ 0.2.1) 
# v0.8 added drive space graphic rather than text & no red dot blast status - off by default due to potential problems in post http://www.tivocommunity.com/tivo-vb/showthread.php?s=&threadid=153504
# v0.9 changed graphic generation - gets round memdump problem
# v0.10 added thumbs on to-do list and end time for to-do list items
# v0.11 added links from thumbs to lj's thumbs module
# v0.12 added endpad - de-prioritised suggestions colouring and graphic
# v0.12 cont. added links on the conflict side to series - taking advantage of lj's slotfree and conflict functionality
# v0.13 added links to re-order season passes
# v0.14 added ability to pass in variable to override hours ahead - and line in email to request new emails with various hours ahead pre-set
# v0.14 cont. fixed bug on endpad which matches date / time incorrectly with output of ls file.
# v0.15 added in support for suggestion equalisation with endpad - cs modified version (not endpadplus)
# v0.16 updated endpad - de-prioritised suggestions colouring and graphic - to stop warning for those suggestion cancelled by start padding of a following recording - which is not the actual case
# v0.17 added some experimental support for the version variable, seemingly required for tivowebplus - may need extra work and validation
# v0.18 added the ability to pass in an alternate email recipient instead of standard.
# v0.19 also, added capability to handle endpadplus functionality where suggestions + recordings are all equal
# v0.20 added functionality to send additional emails with any overrided recipient info passed on - requires appropriate senddailymail.itcl file.
# v0.21 added general healthcheck functionality from PortlandPaw
# v0.22 added emergency temperature indicator
# v0.23 fixed bug with sending override email from tivoweb - from tivoweb email always appears in argument 2, even with blank hours ahead value
# v0.24 module now saves html to an html file for viewing via a web-server or tivoweb module.
# v0.25 ability to send message via tivoweb only - uses a message file
# v0.26 added expiry and conflict major debugging code to support some people with errors
# v0.27 added version number to generated email
# v0.28 added ability to send up to 3 email recipients via command line - with a max of 4 arguments in total
# v0.29 added dynamic debugging capability & extra message when manually requesting email from email - required new .cfg file. Also, removed no-red-dot start link as does not work.
# v0.30 added capability to login to mail server with base 64 encoded username and password
# v0.31 added american spelling / date options; fixed some spelling mistakes
# v0.32 added stuliet's <tr> expiry section fix; added debugging when sending message body if deguglvl is bigger than 2; added "httpd-tt.tcl" for tivoweb running hacks suggestion by PortlandPaw; added time into debug comments;
# v0.32 cont. added sandertons pathname function so the directory of the .cfg file need not be specified and other local files - as long as in same directory; added del4's additions including daily call info, endpad and noreddot added to hacks, view cron task list
# v0.32 cont. added record list (rejection list) options section; added daily list seperator capability with offset; added verbose via alert only bulletin options.
# v0.33 tidied & bug fixed for beta-release.
# v0.34 fixed basic cron issues - and made cron list optional through variables in cfg file. Also added optionality on previous and future sections in rejected recording list through .cfg file.
# v0.34 cont. added in max buffer length / buffer configuration for email sending.
# v0.35 fixed editor issues in sister .itcl files.
# v0.35 cont. after initial beta testing fixed "continuereasons" variable error, fixed cron string to number conversion error, fixed ($h + tzoffset) error in cron area, added "151" to dtivo selection criteria, added temperature variables in cfg file and appropriate changes in this file & added various delays to avoid locking / db errors
# v0.35 cont. after initial beta testing added various "later" commands and "unset" commands to streamline code & removed [base64enc] function calls.
# v0.35 cont. parameterized for tivowebplus users & updated enpad process currency command to remove chance of incorrect status reporting.
# v0.35 cont. general tidy up to reduce error likelihood on LJ's code, fixed SMART incorrect response bug & added complete multine response email server handling
# vo.35 cont. restructured expiry section to ensure that list is ordered correctly and fixed WOW temperature bug. Added significant debugging comments into rejected re ording section.
#
# VERSION INFORMATION SET HERE:
set software_version "0.35.6"
set software_release_date "14th April 2004"
#
#
#
#


global alertcolour
global authreq
global channeltablefsid
global debuglvl
global diskfilename
global dlc
global dmailConflicts
global dmailExpired
global dmailGraphicsURL
global dmailHoursahead
global dmailLinksOn
global dmailShowSuggestions
global dmailTivoStatus
global dmailTivoURL
global dmailToDoList
global drivespacegig
global emailsendrequired
global verylowtempcentigrade
global lowtempcentigrade
global midtempcentigrade
global hightempcentigrade
global toohightempcentigrade
global emergencytempcentigrade
global emergencytempfilename
global endpadendpadmin
global endpadexecfilename 
global endpadinstalled
global endpadlogloc 
global endpadofffilename
global endpadonfilename
global endpadrecordingunlikelygraphic 
global endpadstartpadmin
global endpadstatus 
global everythingeq
global face
global fontfamily
global graphiclengthmultiple 
global graphicson
global headingcolour
global headingsizepx
global highthreshold 
global htmlfilename
global htmlfilerequired
global listcmd
global listtablecolumn1widthpx
global listtablecolumn2widthpx
global listtablecolumn3widthpx
global listtablewidthpx
global mailcheckingon
global mailfilename
global midthreshold 
global noreddotexecfilename 
global normaltextsizepx
global nowshowingdir
global onethumbdowngraphic 
global onethumbupgraphic
global optionalmessagefilename
global password_base64
global phonefilename
global pidfilelocation
global pslocation
global rebootfilename
global recipient2
global recipient3
global reddotinstalled
global reddotofffilename
global reddotonfilename 
global reddotstatus
global reload
global sender
global senderName
global smalltextsizepx
global spacebarrequired
global spacegraphicempty
global spacegraphicend 
global spacegraphichigh 
global spacegraphiclow 
global spacegraphicmid 
global spacegraphicstart 
global squareonethumbdowngraphic 
global squareonethumbupgraphic 
global squarethreethumbdowngraphic 
global squarethreethumbupgraphic 
global squaretwothumbdowngraphic 
global squaretwothumbupgraphic 
global suggestioneq
global tablebordercolour
global tablecolour
global threethumbdowngraphic 
global threethumbupgraphic 
global titlesizepx
global tivologofilename
global twothumbdowngraphic 
global twothumbupgraphic 
global tzoffset
global uktivo
global usedspacegig
global username_base64
global version 
global version3
global viewthumbs
global yankspeak
global listseperator
global listseperatoroffset
global bulletinverbose 
global msgfilename
global cronloc
global cronlistrequired
global rejectedrecreq
global smartCmd
global tivowebmodulesdir
global tivowebdir
global tivowebplususer
global tivoip

set pathname [file dirname [info script]]
source $pathname/dailymail.cfg

## move the list seperator offset from hours to seconds
set listseperatoroffset [expr $listseperatoroffset * 3600]

puts ""
puts ""
puts "------welcome to the jazzed dailymail program - v$software_version ($software_release_date) - starting"
puts "------the debug level is set at >>$debuglvl<<"
if {$yankspeak} { puts "------generated content presented in American English for your reading pleasure!" }
puts "------started at [clock format [clock seconds] -format {%H:%M:%S} -gmt true] (debugging times specified in gmt)"
puts ""

if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-global variable definition complete" }

if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-commence fooling tivoweb modules" }

#needed to fool TiVoWeb modules that they are being called by TiVoWeb :)
global reload
global dlc
set reload 1
set dlc 1
set channeltablefsid {}

if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-completed fooling tivoweb modules" }

setpri fifo 1
catch {EnableTransactionHoldoff true}

proc strim {str} {
	return [string trim $str "\{\}"]
}

if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-completed other preperation" }

###############################################
## sort out arguments passed in

set argument1  [lindex $argv 0]
set argument2  [lindex $argv 1]
set argument3  [lindex $argv 2]
set argument4  [lindex $argv 3]

set originalhoursahead $dmailHoursahead
set originalrecipient $recipient

if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-argument 1 passed in ::: >>$argument1<<" }
if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-argument 2 passed in ::: >>$argument2<<" }
if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-argument 3 passed in ::: >>$argument3<<" }
if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-argument 4 passed in ::: >>$argument4<<" }

set numargs 0

###############################################
## count those argument

if { $argument1 != "" } {
	set numargs [expr $numargs + 1]
}
if { $argument2 != "" } {
	set numargs [expr $numargs + 1]
}
if { $argument3 != "" } {
	set numargs [expr $numargs + 1]
}
if { $argument4 != "" } {
	set numargs [expr $numargs + 1]
}
if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-$numargs argument(s) found" }


set emailonefound 0
set emailtwofound 0
set emailthreefound 0
set hoursfound 0
set hoursahead -1
set numemails 0
set recipient2 ""
set recipient3 ""


###############################################
## check out argument 1

if { [string first "@" $argument1] > -1  && [string first "." $argument1] > -1 && $argument1 != ""} {
	set numemails [expr $numemails + 1]
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-a new recipient e-mail found in argument 1" }
	set emailonefound 1
	set recipient $argument1
} else {
	if { $numargs > 0 } {
		set hoursfound 1
		set hoursahead $argument1
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-a new hours ahead value found in argument 1" }
	}

}

###############################################
## check out argument 2

if { [string first "@" $argument2] > -1  && [string first "." $argument2] > -1 && $argument2 != ""} {
	set numemails [expr $numemails + 1]
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-a new recipient e-mail found in argument 2" }
	if { $emailonefound != 0} {
		set emailtwofound 2
		set recipient2 $argument2
	} else {
		set emailonefound 2
		set recipient $argument2
	}
} elseif { $numargs > 1 && $hoursfound == 0 } {
		set hoursfound 2
		set hoursahead $argument2
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-a new hours ahead value found in argument 2" }
		
}

###############################################
## check out argument 3

if { [string first "@" $argument3] > -1  && [string first "." $argument3] > -1 && $argument3 != ""} {
	set numemails [expr $numemails + 1]
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-a new recipient e-mail found in argument 3" }
	if { $emailonefound != 0} {
		if { $emailtwofound != 0} {
			set emailthreefound 3
			set recipient3 $argument3
		} else {
			set emailtwofound 3
			set recipient2 $argument3
		}
	} else {
		set emailonefound 3
		set recipient $argument3

	}
} elseif { $numargs > 2 && $hoursfound == 0 } {
		set hoursfound 3
		set hoursahead $argument3
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-a new hours ahead value found in argument 3" }
}

###############################################
## check out argument 4

if { [string first "@" $argument4] > -1  && [string first "." $argument4] > -1 && $argument4 != ""} {
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-a new recipient e-mail found in argument 4" }
	set numemails [expr $numemails + 1]
	if { $emailonefound != 0} {
		if { $emailtwofound != 0} {
			set emailthreefound 4
			set recipient3 $argument4
		} else {
			set emailtwofound 4
			set recipient2 $argument4
		}
	} else {
		set emailonefound 4
		set recipient $argument4

	}
} elseif { $numargs > 3 && $hoursfound == 0 } {
		set hoursfound 4
		set hoursahead $argument4
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-a new hours ahead value found in argument 4" }
}


###############################################
## if too many emails sent in the sort that out

if {$numemails > 3} {
	set numemails 3
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-only 3 e-mail recipients allowed - discarding number 4" }
}

###############################################
## sort out an hour variable if entered
	
if { $hoursfound > 0 } {
	if {$dmailHoursahead <= 0  || $dmailHoursahead > 500} {
		if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-Hours in syntax incorrect - use integers!" }
		if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-Using original hours defined in configuration file!" }
		if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-Remember - an e-mail recipient must be in format xxxxxxxx@xxxxxxx.xx" }
		set dmailHoursahead $originalhoursahead
	} else {
		set dmailHoursahead $hoursahead
		if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-hours ahead value is now : >>$dmailHoursahead<<" }
	}
} 


###############################################
## sort out email recipient variable if entered

if {$debuglvl>0} {
	if { $emailonefound > 0 || $emailtwofound > 0 || $emailthreefound > 0} {
		if {$recipient!=""} {puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-recipient e-mail value is now : >>$recipient<<" }
		if {$recipient2!=""} {puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-recipient2 e-mail value is now : >>$recipient2<<" }
		if {$recipient3!=""} {puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-recipient3 e-mail value is now : >>$recipient3<<" }
	} 
}

if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-argument handling complete" }

######################################################################
## message handling

if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-start optional message handling" }

	set optionalmsg {}
	
	if { [file exists $msgfilename] } {
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-message file found" }
		catch {
			set fsize [file size "$msgfilename"]
			if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-fsize : >>$fsize<<" }
			set msgfile [open "$msgfilename" "r"]
			while { ! [eof $msgfile] } {
				set line [gets $msgfile]
				if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-line : >>$line<<" }
				if {$line != ""} {
					 lappend optionalmsg $line
				}
			}
			close $msgfile
		}
		catch {
			if {$debuglvl>1} {puts  "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-about to delete message file" }
			file delete -force $msgfilename
			if {$debuglvl>1} {puts  "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-message file deleted" }
		}
	} else {
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-no message file found"}
	}
	

if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-end optional message handling" }

## end of message handling
######################################################################


#####################################################
## From TiVoWeb's ui.itcl
##  Copyright (c) 2002 Aaron Schrab <aaron@schrab.com>

proc alt_showing_conf {tofind_tmsid tofind_fsid} {

	global db

	set showings [get_programshowings $tofind_fsid 1]

	foreach showing $showings {
		set seconds [lindex $showing 0]
		set stationfsid [lindex $showing 1]
		set date [expr $seconds / 86400]
		set time [expr $seconds % 86400]
		set timestr [format "%05d" $time]
		ForeachMfsFile recfsid name type "/Recording/Active" "4:$date:$timestr:" {
			RetryTransaction {
				set rec [db $db openid $recfsid]
				set show [dbobj $rec get Showing]
				set prog [dbobj $show get Program]
				set id [dbobj $prog get TmsId]
				if {$id == $tofind_tmsid} {
					return "todo [dbobj $show fsid]/[dbobj $show subobjid]"
				}
				unset rec
			}
		}
	}

	# Also check if it's in Now Showing
	
	ForeachMfsFile recfsid name type  "/Recording/TmsId" "$tofind_tmsid:" {
		RetryTransaction {
			set rec [db $db openid $recfsid]
			set show [dbobj $rec get Showing]
			unset rec
			return "nowshowing [dbobj $show fsid]/[dbobj $show subobjid]"
		}
	}

	return ""
}


#####################################################
## From TiVoWeb's httpd-tt.tcl by mbm

proc get_tzoffset {mfstz dst} {

	global debuglvl

	if { $mfstz <= 0 } {
		set tz $mfstz
	} else {
		set tzlist "-5 -6 -7 -8 -9 -10 0 1 2 3 4 5 6 7 8 9 10 11 12 -1 -2 -3 -4 -11 -12"
		set tz [lindex $tzlist [expr $mfstz - 1]]
	}
	if { $dst == 2 } {
		set date [clock format [clock seconds] -format "%1d %w %1m %1H %1M"]
		scan $date "%d %d %d %d %d" dom dow month hour min
		set dlsval 0
		if {$::uktivo} {
			if {$month > 3 && $month < 10} {
				set dlsval 1
			} elseif {$month == 3 && $dom >= 25 && $dow == 0 && $hour >= 1} {
				set dlsval 1
			} elseif {$month == 3 && $dom >= 25 && $dow != 0 && ($dom-24-$dow >= 1) } {
				set dlsval 1
			}
		} else {
			if {$month > 4 && $month < 10} {
				set dlsval 1
			} elseif {$month == 4 && $dom > 7} {
				set dlsval 1
			} elseif {$month == 4 && $dom <= 7 && $dow == 0 && $hour >= 2} {
				set dlsval 1
			} elseif {$month == 4 && $dom <= 7 && $dow != 0 && ($dom-$dow > 0)} {
				set dlsval 1
			}
		}
		if {$dlsval == 0} {
			if {$month == 10 && $dom < 25} {
				set dlsval 1
			} elseif {$month == 10 && $dom >= 25 && $dow == 0 && $hour < 2} {
				set dlsval 1
			} elseif {$month == 10 && $dom >= 25 && $dow != 0 && ($dom-24-$dow < 1) } {
				set dlsval 1
			}
		}
		if {$dlsval == 1} {
			if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-tzoffset : >>[expr ($tz+1)*60*60]<<" }
			return [expr ($tz+1)*60*60]
			
		} else {
			if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-tzoffset : >>[expr $tz*60*60]<<" }
			return [expr $tz*60*60]
		}
	} else {
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-tzoffset : >>[expr $tz*60*60]<<" }
		return [expr $tz*60*60]
	}
}



#####################################################
## Sends results as an e-mail

proc sendmail {mailserver domain recipient subject message} {



	global sender
	global senderName
	global debuglvl
	global authreq
	global username_base64
	global password_base64
	global yankspeak
        global tzoffset
        global tivowebplususer
        global tivoip
                
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-entered sendmail procedure" }

	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-variable check:" }
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-mailserver : >>$mailserver<<" }
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-domain : >>$domain<<" }
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-recipient : >>$recipient<<" }
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-subject: >>$subject<<" }
	
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-attempting to open socket 25 to mailserver specified >>$mailserver<<" }
		
	if {$tivowebplususer} {
		set chan [socket -myaddr $tivoip $mailserver 25]
	} else {
		set chan [socket $mailserver 25]
	}	
	gets $chan reply
	while {[string range $reply 3 3] == "-"} {
		gets $chan reply
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-got reply (multi-line) : >>$reply<<" }
	}
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-got reply : >>$reply<<" }
	#<server>220 [server name] [server capabilities]
	if {[lindex $reply 0] != "220"} {
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-bad connection" }
		exit 0
	} else {
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-connected" }
	}
	
	fconfigure $chan -buffering line -buffersize 4096

	puts $chan "HELO $domain"

	flush $chan
	gets $chan reply
	while {[string range $reply 3 3] == "-"} {
		gets $chan reply
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-got reply (multi-line) : >>$reply<<" }
	}
	
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-got reply : >>$reply<<" }
	#<server>250 [informational message, usually server name]
	if {[string range $reply 0 2] != "250"} {
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-connection rejected" }
		exit 0
	} else {
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-helo acknowledged" }
	}
	
	if {$authreq} {
	
		puts $chan "AUTH LOGIN $username_base64"
		flush $chan
		gets $chan reply
		while {[string range $reply 3 3] == "-"} {
			gets $chan reply
			if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-got reply (multi-line) : >>$reply<<" }
		}
		
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-got reply : >>$reply<<" }
		#<server>334 [usually password encoded in base 64]
		if {[string range $reply 0 2] != "334"} {
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-username rejected" }
			exit 0
		} else {
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-username accepted" }
		}
	
		puts $chan "$password_base64"

		flush $chan
		gets $chan reply
		while {[string range $reply 3 3] == "-"} {
			gets $chan reply
			if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-got reply (multi-line) : >>$reply<<" }
		}
		
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-got reply : >>$reply<<" }
		#<server>235 [informational message, usually Authentication Successful]
		if {[string range $reply 0 2] != "235"} {
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-password incorrect" }
			exit 0
		} else {
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-password accepted" }
		}
	}	
	

	puts $chan "MAIL FROM:<$sender>"
	flush $chan
	gets $chan reply
	while {[string range $reply 3 3] == "-"} {
		gets $chan reply
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-got reply (multi-line) : >>$reply<<" }
	}
	
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-got reply : >>$reply<<" }
	#<server>250 ok
	if {[string range $reply 0 2] != "250"} {
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-connection rejected" }
		exit 0
	} else {
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-from acknowledged" }
	}

	puts $chan "RCPT TO:<$recipient>"
	flush $chan
	gets $chan reply
	while {[string range $reply 3 3] == "-"} {
		gets $chan reply
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-got reply (multi-line) : >>$reply<<" }
	}
	
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-got reply : >>$reply<<" }
	#<server>250 ok
	if {[string range $reply 0 2] != "250"} {
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-connection rejected" }
		exit 0
	} else {
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-to acknowledged" }
	}
	puts $chan "DATA"
	flush $chan
	gets $chan reply
	while {[string range $reply 3 3] == "-"} {
		gets $chan reply
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-got reply (multi-line) : >>$reply<<" }
	}
	
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-got reply : >>$reply<<" }
	#<server>354 go ahead
	if {[string range $reply 0 2] != "354"} {
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-connection rejected" }
		exit 0
	} else {
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-sending message" }
	}
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-building header" }
	puts $chan "Subject: $subject"
	flush $chan
	if {$yankspeak} {
		puts $chan "Date: [clock format [expr [clock seconds] + $tzoffset] -format {%A, %B %d, %Y %I:%M:%S%p}]"
	} else {
		puts $chan "Date: [clock format [clock seconds] -format {%a, %d %b %Y %H:%M:%S (%Z)} -gmt true]"
	}
	flush $chan
	puts $chan "From: \"$senderName\" <$sender>"
	flush $chan
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-about to set recipient" }
	puts $chan "To: $recipient"
	flush $chan
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-recipient set" }
	puts $chan "Message-Id: [clock seconds]@$domain"
	flush $chan
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-building content" }
	puts $chan "MIME-Version: 1.0"
	flush $chan
	puts $chan "Content-type: text/html"
	flush $chan
	puts $chan ""
	flush $chan
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-html starts" }
	puts $chan "<html>"
	flush $chan
	puts $chan "<head>"
	flush $chan
	outputStyleSheet $chan
	puts $chan "</head>"
	flush $chan
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-body starts" }
	puts $chan "<body>"
	flush $chan
	if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug---------------------------------------------------------------------------------------------------------------------" }
	foreach item $message {
		foreach part $item {
			foreach line $part {
				if {$debuglvl>2} { puts "[strim $line]" }
				foreach word $line {
					puts $chan [strim $word]
				}
			}
		}
	}
	if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug---------------------------------------------------------------------------------------------------------------------" }
	flush $chan
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-body ended" }
	puts $chan "</body> </html>  "
	flush $chan
	puts $chan ""
	flush $chan
	puts $chan ""
	flush $chan
	puts $chan "."
	flush $chan
	gets $chan reply
	while {[string range $reply 3 3] == "-"} {
		gets $chan reply
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-got reply (multi-line) : >>$reply<<" }
	}
	
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-got reply : >>$reply<<" }
	#<server>250 [informational message]
	if {[string range $reply 0 2] != "250"} {
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-sending failed"}
		exit 0
	} else {
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-message sent"}
	}
	puts $chan "quit"
	flush $chan
	gets $chan reply
	while {[string range $reply 3 3] == "-"} {
		gets $chan reply
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-got reply (multi-line) : >>$reply<<" }
	}
	
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-got reply : >>$reply<<" }
	#<server>221 [informational message]
	if {[string range $reply 0 2] != "221"} {
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-disconnect failed"}
		exit 0
	} else {
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-disconnected"}
	}
	close $chan
}


#####################################################
## Save results as an html file

proc writehtml {message} {

	global htmlfilename
	global debuglvl
	global yankspeak
        global tzoffset
	
	set htmlfilename $htmlfilename
	set htmlfile [open $htmlfilename "w"]
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-building html content"}
	puts $htmlfile ""
	flush $htmlfile
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-html starts"}
	puts $htmlfile "<html>"
	flush $htmlfile
	puts $htmlfile "<head>"
	flush $htmlfile
	outputStyleSheet $htmlfile
	puts $htmlfile "</head>"
	flush $htmlfile
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-body starts"}
	puts $htmlfile "<body>"
	flush $htmlfile
	if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug---------------------------------------------------------------------------------------------------------------------" }
		foreach item $message {
		foreach part $item {
			foreach line $part {
				if {$debuglvl>2} { puts "[strim $line]" }
				foreach word $line {
					puts $htmlfile [strim $word]
				}
			}
		}
	}
	if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug---------------------------------------------------------------------------------------------------------------------" }
	puts $htmlfile "<br><br>"
	flush $htmlfile
	if {$yankspeak} {	
		puts $htmlfile "Generated on <i>[clock format [expr [clock seconds] + $tzoffset] -format {%A, %B %d %I:%M%p}]</i>"
	} else {
		puts $htmlfile "Generated on <i>[clock format [clock seconds] -format {%a, %d %b %H:%M} -gmt true]</i>"
	}
	flush $htmlfile
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-body ended"}
	puts $htmlfile "</body> </html>  "
	flush $htmlfile
	puts $htmlfile ""
	flush $htmlfile
	close $htmlfile
	
}




#####################################################
## Get unresolved conflicts

proc getconflicts {hoursahead} {

	global db
	global tzoffset
	global dmailTivoURL
	global dmailGraphicsURL
	global dmailLinksOn
	global debuglvl
	global yankspeak
	global listseperator
	global listseperatoroffset
	
	set text ""
	
	set oldday ""
	
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-compiling conflicts list"}

	set conflicts {}
	if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug=====================================================================" }
	
	after 2000
	
	ForeachMfsFile fsid name type "/Recording/History" "" {
	
		if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint conflict 000"}
		
		set debugfinished false
		set gottabreak false
		
		catch { 
		
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-just inside catch area" }
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-name : >>$name<<"}
			set recdate [split $name ":"]
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-recdate : >>$recdate<<"}
			regsub {^(-?)0+([1-9])} [lindex $recdate 1] {\1\2} thetime
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-thetime : >>$thetime<<"}
			set rectime [expr [lindex $recdate 0] * 86400 + $thetime]
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-rectime : >>$rectime<<"}
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-prior to check for time ahead"}
			if {$rectime > [expr [clock seconds] + $hoursahead * 3600]} {
				set debugfinished true
				set gottabreak true
				break
			}
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-within time period for checking"}
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint conflict 001"}
	
			if {$rectime > [clock seconds]} {
	
				RetryTransaction {
					if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint conflict 002 - inside retry transaction loop"}
					set rec [db $db openid $fsid ]
					set creason [dbobj $rec get CancelReason]
					set showing [dbobj $rec get Showing]
					set showingfsid [dbobj $rec gettarget Showing]
					set station [dbobj $showing get Station]
					set callsign [dbobj $station get CallSign]
					set program [dbobj $showing get Program]
					set title [strim [dbobj $program get Title]]
					set id [dbobj $program get TmsId]
					set id2 [dbobj $program fsid]
					set descr [strim [dbobj $program get Description]]
					set series [dbobj $program get Series]
					set seriesfsid [dbobj $series fsid]
					unset rec
					
					if {$yankspeak} {
						set nowday [clock format [expr $rectime +  $tzoffset - $listseperatoroffset] -format {%A, %B %d}]
					} else {
						set nowday [clock format [expr $rectime + $tzoffset  - $listseperatoroffset] -format {%a, %d %b}]
					}
					
					if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint conflict 003"}
					if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-fsid : >>$fsid<<"}
					if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-creason : >>$creason<<"}
					if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-showing : >>$showing<<"}
					if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-showingfsid : >>$showingfsid<<"}
					if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-station : >>$station<<"}
					if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-callsign : >>$callsign<<"}
					if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-title : >>$title<<"}
					if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-program:: >>$program<<"}
					if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-series : >>$series<<"}
					if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-seriesfsid : >>$seriesfsid<<"}
	
					if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint conflict 004"}
					if {$series != ""} {
						set episodic [defaultval 1 [dbobj $series get Episodic]]
					} else {
						set episodic 1
					}
					if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint  conflict 005"}
					if { $episodic == 1 } {
						set eptitle [strim [dbobj $program get EpisodeTitle]]
						if { $eptitle == "" } {
							set eptitle "No Episode Title"
						}
					} else {
						set eptitle ""
					}
				}
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint conflict 006"}
				if {$creason == 20} {
	
					set alt [alt_showing_conf $id $id2]
					
					if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint conflict 007"}
	
					if {$alt == ""} {
						set text {}
						
						### start blank date row insert 
						if {$listseperator} {
							if {$oldday != $nowday} {
								lappend text "<tr><td class=seperator>$nowday</td>"
								if {$dmailLinksOn} {
									lappend text "<td class=links>&nbsp;</td>"				
								}
								lappend text "</tr>"			
								set oldday $nowday
							}
						}
						### end blank date row insert
	
						lappend text "<tr><td class=programme><strong>"
						lappend text "$title" 
						lappend text "</strong>"
						if {$yankspeak} {
							lappend text "[clock format [expr $rectime + $tzoffset] -format {%a %I:%M%p}] $callsign"
						} else {	
							lappend text "[clock format [expr $rectime + $tzoffset] -format {%a %H:%M}] $callsign"
						}
						lappend text "<br>"
	
						if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint conflict 008"}
				
						if {$eptitle !=""} {
  							if {$descr !=""} {
								lappend text "$eptitle - $descr"
   							} else {
								lappend text "$eptitle"
  							}
						} else {
  							if {$descr !=""} {
								lappend text "$descr"
  							} else {
								lappend text "No description."
							}
						}
						if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint conflict 009"}
						if {$dmailLinksOn} {
							lappend text "</td><td class=links>"
							lappend text "<a href=\"$dmailTivoURL/showing/$showingfsid\" target=\"_blank\">view details</a><br>"
							lappend text "<a href=\"$dmailTivoURL/series/$seriesfsid\" target=\"_blank\">view slots </a>"
						}		
						
						lappend text "</td></tr>"
	
						lappend conflicts $text
						if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint conflict 010"}
					}
				}
			}
		set debugfinished true
		}
		
		if {$debugfinished} {
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-conflict item success"}
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug----------------------------------------------------------------------"}
		} else {
			
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-conflict error occurred with item"}
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug----------------------------------------------------------------------"}
		}
		if {$gottabreak} {
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-quit out of conflict loop"}
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug====================================================================="}
			break
		}
	}
	
	unset text
		
	return $conflicts
}


proc get_thumbimage {score} {
	set thumbdata [ReadableThumbs $score]
	scan $thumbdata "%s %d" thumbtype numthumbs
	if {$thumbtype == "Predicted"} {
	   switch -- $numthumbs {
		  -3 {set imagenum 14}
		  -2 {set imagenum 15}
		  -1 {set imagenum 16}
		  1 {set imagenum 17}
		  2 {set imagenum 18}
		  3 {set imagenum 19}
		  default {set imagenum -1}
	   }
	} else {
	   switch -- $numthumbs {
		  -3 {set imagenum 9}
		  -2 {set imagenum 6}
		  -1 {set imagenum 4}
		  1 {set imagenum 12}
		  2 {set imagenum 2}
		  3 {set imagenum 7}
		  default {set imagenum -1}
	   }
	}
	return $imagenum
}


#####################################################
## Generate To Do List

proc gettodo {hoursahead} {

	global db
	global version3
	global tzoffset
	global dmailTivoURL
	global dmailGraphicsURL
	global dmailLinksOn
	global dmailShowSuggestions
	global tivoswversion
	global viewthumbs
	global graphicson
	global endpadinstalled
	global endpadstatus
	global endpadstartpadmin
	global endpadendpadmin
	global endpadstarttimes
	global endpadendtimes
	global endpadrectype
	global endpadrecstatus
	global norecordmessage
	global onethumbupgraphic
	global twothumbupgraphic 
	global threethumbupgraphic 
	global onethumbdowngraphic 
	global twothumbdowngraphic 
	global threethumbdowngraphic 
	global squareonethumbupgraphic 
	global squaretwothumbupgraphic 
	global squarethreethumbupgraphic 
	global squareonethumbdowngraphic 
	global squaretwothumbdowngraphic 
	global squarethreethumbdowngraphic 
	global endpadrecordingunlikelygraphic 
	global suggestioneq
	global everythingeq
	global debuglvl
	global yankspeak
	global listseperator
	global listseperatoroffset
	
	if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-compiling to do list"}

	set message {}
	
	set text ""

	set path "/Recording/Active"
	set prefix "4"

	set numofitems 0
		
	if { $endpadinstalled && $endpadstatus } {
	
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-need to look for overlapping programs with endpad"}
	
		###########################################
		## endpad pre-check
	
		set endpadstarttimes "Dummy"
		set endpadendtimes "Dummy"
		set endpadrectype "Dummy"
		set endpadrecstatus "Dummy"
		set norecordmessage "Dummy"
	
		after 2000
		
		ForeachMfsFileTrans fsid name type $path $prefix 10 {

			set rec [db $db openid $fsid]
			set showing [dbobj $rec get Showing]
			set starttime [expr [dbobj $showing get Date] * 86400 + [dbobj $showing get Time]]
		
			if {$starttime <= [expr ($hoursahead *3600) + [clock seconds]]} {
			
				set duration [dbobj $showing get Duration]
				set endtime [expr $starttime + $tzoffset + $duration]
				set starttime [expr $starttime + $tzoffset]	
				lappend endpadstarttimes "$starttime"
				lappend endpadendtimes "$endtime"	
				if {$::version3} {
					set recbeh [dbobj $rec get RecordingBehavior]
					set seltype [dbobj $recbeh get PresentationBehavior]
				} else {
					set seltype [dbobj $rec get SelectionType]
				}
				if {$seltype == 6} {
					lappend endpadrectype "Suggestion"
				} else {
					lappend endpadrectype "Other"		
				}
				set numofitems [ expr $numofitems + 1 ]
			}
			unset rec
		}	 
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-$numofitems items to investigate for endpad programme overlapping"}
		set currentcount 1
		set endpadrecstatus "Dummy"
		set runningmessage ""
		
		#######################################
		## check overlaps
		
		while { $currentcount <= $numofitems } {
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug--------------------------------------"}
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-item: $currentcount"}
			set currentitemrecord true
			set runningmessage ""
			
			#################################################################################################
			## endpadplus makes both suggestions + recordings equal so nothing will ever be cancelled
			
			if {$everythingeq} {
				# do nothings - everything is equal
			} else {
			
				###################################################################################################
				## need to check that this programme is not a suggestion and the end encroaches on a non suggestion
				## removed for v0.16 - because this is not how endpad actually works.
				## start padding is only added if there is nothing before hand - a suggestion or a proper recording
				##
				##if { [ lindex $endpadrectype $currentcount ] == "Suggestion" && [ lindex $endpadrectype [ expr $currentcount + 1 ] ] == "Other" } {
				##	if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-check end time overlap"}
				##	if { [ lindex $endpadendtimes $currentcount ] > [ expr [ lindex $endpadstarttimes [ expr $currentcount + 1 ] ] - [ expr $endpadstartpadmin * 60 ] ] } {
				##		set currentitemrecord false
				##		if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-there is an overlap -> this programme will probably not be recorded"}
				##		set runningmessage "Adding&nbsp;start-padding&nbsp;to&nbsp;the&nbsp;next&nbsp;recording will&nbsp;cause&nbsp;this&nbsp;suggestion&nbsp;to&nbsp;be&nbsp;cancelled."
				##	} else {
				##		if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-there is no overlap"}
				##	}
				##}
				##
				#####################################################################################################
				# now we need to check that this programme is not a suggestion and the beginning would be overlapped by a previous non suggestion ...
				
				if { $currentcount != 1 && $currentitemrecord} {
					if { [ lindex $endpadrectype $currentcount ] == "Suggestion" && [ lindex $endpadrectype [ expr $currentcount - 1 ] ] == "Other" } {
						if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-check start time overlap"}
						if { [ lindex $endpadstarttimes $currentcount ] < [ expr [ lindex $endpadendtimes [ expr $currentcount - 1 ] ] + [ expr $endpadendpadmin * 60 ] ] } {
							set currentitemrecord false
							if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-there is an overlap -> this programme will probably not be recorded"}
							set runningmessage "Adding&nbsp;end-padding&nbsp;to&nbsp;the&nbsp;previous&nbsp;recording will&nbsp;cause&nbsp;this&nbsp;suggestion&nbsp;to&nbsp;be&nbsp;cancelled."
						} else {
							if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-there is no overlap"}
						}
					}
				}
				
				##########################################################################################################
				## now we need to check that this programme is not a suggestion and the beginning would be overlapped by a previous suggestion that is recording
				
				if { $currentcount != 1 && $currentitemrecord && [ strim [ lindex $endpadrecstatus [ expr $currentcount - 1 ] ] ] != "NoRecord"} {
				
					if { [ lindex $endpadrectype $currentcount ] == "Suggestion" && [ lindex $endpadrectype [ expr $currentcount - 1 ] ] == "Suggestion" } {
						if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-check start time overlap for back-to-back suggestions"}
						
						#####################################################################################################################
						## updated endpad provides suggestion equalisation functions - only run next code if equalisation not active / available
							
						if { $suggestioneq } {
							# null
							if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-suggestion equalisation is on - back-to-back suggestions allowed"}
						} else {
							if { [ lindex $endpadstarttimes $currentcount ] < [ expr [ lindex $endpadendtimes [ expr $currentcount - 1 ] ] + [ expr $endpadendpadmin * 60 ] ] } {
								set currentitemrecord false
								if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-there is an overlap -> this programme will probably not be recorded"}
								set runningmessage "Adding&nbsp;end-padding&nbsp;to&nbsp;the&nbsp;previous&nbsp;suggestion will&nbsp;cause&nbsp;this&nbsp;suggestion&nbsp;to&nbsp;be&nbsp;cancelled."
						
							} else {
								if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-there is no overlap"}
							}
						}	
					}
				}
			}
			if { $currentitemrecord } {
				lappend endpadrecstatus "Record"
				lappend norecordmessage "x"
			} else {
				lappend endpadrecstatus "NoRecord"
				lappend norecordmessage "$runningmessage"
			}
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-item status : >>[lindex $endpadrecstatus $currentcount]<<"}
			set currentcount [ expr $currentcount + 1 ]
		}	
	}
	
	
	#####################################
	## main loop
	
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-starting main to-do loop"}
	set currentcount 1
	set oldday ""
	
	after 2000
	
	ForeachMfsFileTrans fsid name type $path $prefix 10 {
		set rec [db $db openid $fsid]
		set showing [dbobj $rec get Showing]
		set starttime [expr [dbobj $showing get Date] * 86400 + [dbobj $showing get Time]]
		if {$starttime > [expr ($hoursahead *3600) + [clock seconds]]} {
			return $message
		}
		set showingfsid [dbobj $rec gettarget Showing]
		set station [dbobj $showing get Station]
		set stationfsid [dbobj $station fsid]
		set callsign [dbobj $station get CallSign]
		set program [dbobj $showing get Program]
		set title [strim [dbobj $program get Title]]
		set descr [strim [dbobj $program get Description]]
		set durationhours [clock format [dbobj $showing get Duration] -format "%H"]
		set durationminutes [clock format [dbobj $showing get Duration] -format "%M"]
		set duration [dbobj $showing get Duration]
		if {$yankspeak} {
			set nowday [clock format [expr $starttime + $tzoffset - $listseperatoroffset] -format {%A, %B %d}]
		} else {
			set nowday [clock format [expr $starttime + $tzoffset - $listseperatoroffset] -format {%a, %d %b}]
		}
		if {$yankspeak} {
			set endtime [clock format [expr $starttime + $tzoffset + $duration] -format {%a %I:%M%p}]
			set starttime [clock format [expr $starttime + $tzoffset] -format {%a %I:%M%p}]
		} else {
			set endtime [clock format [expr $starttime + $tzoffset + $duration] -format {%a %H:%M}]
			set starttime [clock format [expr $starttime + $tzoffset] -format {%a %H:%M}]
		}
		
		set series [dbobj $program get Series]
		if {$viewthumbs} {
			set images " xxx.gif xxx.gif $twothumbupgraphic xxx.gif $onethumbdowngraphic xxx.gif $twothumbdowngraphic $threethumbupgraphic xxx.gif $threethumbdowngraphic xxx.gif xxx.gif $onethumbupgraphic xxx.gif $squarethreethumbdowngraphic $squaretwothumbdowngraphic $squareonethumbdowngraphic $squareonethumbupgraphic $squaretwothumbupgraphic $squarethreethumbupgraphic xxx.gif xxx.gif"
			set seriesfsid ""
			set thumbs ""
			set imagef ""
			if { $series != "" } {
				set seriesfsid [dbobj $series fsid]
				set score [dbobj $series get ThumbData]
				if { $score != "" } {
					set imagenum [get_thumbimage $score]
					if { $imagenum >= 0} {
					      #  puts "image number: $imagenum"
						set imagef [lindex $images $imagenum]
						#set thumbs [img "alt=\"\"" $imagef]
					}
				 }
			}
		}
		if {$::version3} {
			set recbeh [dbobj $rec get RecordingBehavior]
			set seltype [dbobj $recbeh get PresentationBehavior]
		} else {
			set seltype [dbobj $rec get SelectionType]
		}
		if {$series != ""} {
			set episodic [defaultval 1 [dbobj $series get Episodic]]
		} else {
			set episodic 1
		}
		if { $episodic == 1 } {
			set eptitle [strim [dbobj $program get EpisodeTitle]]
			if { $eptitle == "" } {
				set eptitle "No Episode Title"
			}
		} else {
			set eptitle ""
		}
		
		if {$seltype != 6 || $dmailShowSuggestions} {
		
			set text {}
			
			### html generation of to-do list starts here
			
			### start blank date row insert 
			if {$listseperator} {
				if {$oldday != $nowday} {
					lappend text "<tr><td class=seperator>$nowday</td>"
					if {$dmailLinksOn} {
						lappend text "<td class=links>&nbsp;</td>"				
					}
					if {$graphicson && $viewthumbs} {
						lappend text "<td class=thumbs>&nbsp;</td>"			
					}
					lappend text "</tr>"			
					set oldday $nowday
				}
			}
			### end blank date row insert
			
			if {$seltype == 6} {
				if { $endpadinstalled && $endpadstatus } {
					if { [ strim [ lindex $endpadrecstatus $currentcount ] ] == "NoRecord" } {
					
						lappend text "<tr><td class=suggestion><strong>"
					} else {
				
						lappend text "<tr><td class=programme><strong>"		
					}
				} else {
					lappend text "<tr><td class=programme><strong>"
				}
			} else {
				lappend text "<tr><td class=programme><strong>"			
			}
			lappend text "$title" 
			lappend text "</strong> "
			if {$seltype == 6} {
				lappend text "$starttime - $endtime $callsign (Suggestion)"
				if { $endpadinstalled && $endpadstatus } {
					if { [ strim [ lindex $endpadrecstatus $currentcount ] ] == "NoRecord" } {
						if {$graphicson} {
							lappend text "&nbsp;<img src=\"$dmailGraphicsURL/$endpadrecordingunlikelygraphic\" border=\"0\" alt=\"Soft&nbsp;Padding&nbsp;makes&nbsp;this&nbsp;recording&nbsp;unlikely. [lindex $norecordmessage $currentcount]\">"
						} else {
							lappend text "&nbsp;[RECORDING UNLIKELY]\">"
						}
					}
				}
			} else {
				lappend text "$starttime - $endtime $callsign"
			}
			lappend text "<br>"
			if {$eptitle !=""} {
				if {$descr !=""} {
					lappend text "$eptitle - $descr"
				} else {
					lappend text "$eptitle"
				}
			} else {
				if {$descr !=""} {
					lappend text "$descr"
				} else {
					lappend text "No description."
				}
			}
			# lappend text "&nbsp;(Ends @ $endtime)"
			if {$dmailLinksOn} {
				lappend text "</td><td class=links>"
				lappend text "<a href=\"$dmailTivoURL/confirmdelete/2/$fsid\" target=\"_blank\">cancel recording</a><br>"
				lappend text "<a href=\"$dmailTivoURL/showing/$showingfsid\" target=\"_blank\">view details</a>"
			}
			lappend text "</td>"
			if {$graphicson} {
				if {$viewthumbs} {
					if {$imagef != ""} {
						lappend text "<td class=thumbs>"
						if {$dmailLinksOn} {
							lappend text "<a href=\"$dmailTivoURL/thumbs/$seriesfsid\" target=\"_blank\" ><img src=\"$dmailGraphicsURL/$imagef\" border=\"0\" alt=\"Click&nbsp;here&nbsp;to&nbsp;update&nbsp;thumbs.\"></a>"	
						} else {
							lappend text "<img src=\"$dmailGraphicsURL/$imagef\">"				
						}			
						lappend text "</td>"
					} else {
						lappend text "<td class=thumbs>&nbsp;"			
						lappend text "</td>"
					}
				}
			}
			lappend text "</tr>"
			lappend message $text
				
			### html generation of to-do list ends here
			
		}
		set currentcount [ expr $currentcount + 1 ]
		unset rec
		
	}
	
	unset text
	unset endpadstarttimes
	unset endpadendtimes
	unset endpadrectype
	unset endpadrecstatus
	unset norecordmessage
	
	return $message
}



#####################################################
## Generate expiry list

proc getnpexpire {hoursahead} {

	global nowshowingdir
	global tzoffset
	global db
	global dmailTivoURL
	global dmailGraphicsURL
	global dmailLinksOn
	global dmailShowSuggestions
	global debuglvl
	global yankspeak
	global listseperator
	global listseperatoroffset
	
	set expirytitle "Dummy"
	set expiryrectime 999
	set expiryexpsecs 999
	set expiryeptitle "Dummy"
	set expirydescr "Dummy"
	set expiryfsid 999
	set expiryshowingfsid 999
	set expirycount 0

	
	set text ""
	
	if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-compiling expiration list"}

	set message {}
	if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug====================================================================="}
	
	after 2000
	
	ForeachMfsFileTrans fsid name type $nowshowingdir "" 10 {
	
		if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint expire 000"}
		
		set debugfinished false
	
		catch {
			set rec [db $db openid $fsid]	
			set expdate [dbobj $rec get ExpirationDate]
			set expsecs [expr $expdate * 86400 + [dbobj $rec get ExpirationTime]]
			
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint expire 001"}
	
			if {$expsecs < [expr $hoursahead * 3600 + [clock seconds]] && $expsecs > [clock seconds] } {
			
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint expire 002"}
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-within time period"}
				
				set showing [dbobj $rec get Showing]
				set showingfsid [dbobj $rec gettarget Showing]
				set startdate [dbobj $rec get StartDate]
				set starttime [dbobj $rec get StartTime]
				set rectime [expr $startdate * 86400 + $starttime]
				set station [dbobj $showing get Station]
				set stationfsid [dbobj $station fsid]
				set callsign [dbobj $station get CallSign]
				set program [dbobj $showing get Program]
				set title [strim [dbobj $program get Title]]
				set descr [strim [dbobj $program get Description]]
				set series [dbobj $program get Series]
								
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-showing : >>$showing<<"}
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-showingfsid : >>$showingfsid<<"}
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-startdate : >>$startdate<<"}
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-starttime : >>$starttime<<"}
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-rectime : >>$rectime<<"}
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-station : >>$station<<"}
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-callsign : >>$callsign<<"}
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-title : >>$title<<"}
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-program:: >>$program<<"}
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-series : >>$series<<"}		
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint expire 003"}

				if {$series != ""} {
					set episodic [defaultval 1 [dbobj $series get Episodic]]
				} else {
					set episodic 1
				}
	
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint expire 004"}
				
				if { $episodic == 1 } {
					set eptitle [strim [dbobj $program get EpisodeTitle]]
					if { $eptitle == "" } {
						set eptitle "No Episode Title"
					}
				} else {
					set eptitle ""
				}
	
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint expire 005"}
				
				lappend expirytitle $title
				lappend expiryrectime $rectime 
				lappend expiryexpsecs $expsecs
				lappend expiryeptitle $eptitle
				lappend expirydescr $descr
				lappend expiryfsid $fsid
				lappend expiryfsid $showingfsid
	
				set expirycount [expr $expirycount + 1]
				
			}
			set debugfinished true
		}
		if {$debugfinished} {
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-expiry item success"}
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug----------------------------------------------------------------------"}
		} else {
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-expiry error occurred with item"}
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug----------------------------------------------------------------------"}
	
		}
		
		unset rec
	}
	
	
	if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug====================================================================="}
		
	
	
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-ready to go generate list."}
	
	## sort out the list generation aspect
	set runningcount 0
	
	## identify the current day as a base starting point
	set nowsecs [expr [clock seconds] +  $tzoffset - $listseperatoroffset]
	if {$yankspeak} {
		set nowday [clock format [expr $nowsecs +  $tzoffset - $listseperatoroffset] -format {%A, %B %d}]
	} else {
		set nowday [clock format [expr $nowsecs  + $tzoffset - $listseperatoroffset] -format {%a, %d %b}]
	}
	
	if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-about to enter first loop."}
			
	while { $runningcount < $expirycount } {
	
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-test day is >>$nowday<<"}
		
		set text {}
		set i 1
		set firstline "Y"
		
		if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-about to enter second loop"}
		
		while { $i <= $expirycount } {
		
			if {$yankspeak} {
				set itemday [clock format [expr [lindex $expiryexpsecs $i]  + $tzoffset - $listseperatoroffset] -format {%A, %B %d}]
			} else {
				set itemday [clock format [expr [lindex $expiryexpsecs $i] + $tzoffset - $listseperatoroffset] -format {%a, %d %b}]
			}	
			
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-item day is >>$itemday<<"}
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-item details are >>[lindex $expirytitle $i]<< >>[lindex $expiryeptitle $i]<< >>[lindex $expiryfsid $i]<<"}
		
			if { $itemday == $nowday } {
			
				if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-day match identified!"}
				if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-matched item day is >>$itemday<<"}
				if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-matched item details are >>[lindex $expirytitle $i]<< >>[lindex $expiryeptitle $i]<< >>[lindex $expiryfsid $i]<<"}
		
			
				## sort out seperator line
				if {$firstline == "Y"} {
				
					if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-creating seperator line"}
					
					if {$listseperator} {
						lappend text "<tr><td class=seperator>$nowday</td>"
						if {$dmailLinksOn} {
							lappend text "<td class=links>&nbsp;</td>"				
						}
						lappend text "</tr>"
					}				
					set firstline "N"
				}
				
				## sort out the rest		
				
				lappend text "<tr><td class=programme><strong>"
				lappend text "[lindex $expirytitle $i]" 
				lappend text "</strong>"

				if {$yankspeak} {
					lappend text "Recorded [clock format [expr [lindex $expiryrectime $i] + $tzoffset] -format {%A, %B %d %I:%M%p}] $callsign"
					lappend text " - Expires [clock format [expr [lindex $expiryexpsecs $i] + $tzoffset] -format {%a %I:%M%p}]"				
				} else {
					lappend text "Recorded [clock format [expr [lindex $expiryrectime $i] + $tzoffset] -format {%a, %d %b %H:%M}] $callsign"
					lappend text " - Expires [clock format [expr [lindex $expiryexpsecs $i] + $tzoffset] -format {%a %H:%M}]"
				}
	
				lappend text "<br>"
				
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint expire 006"}
		
				if {[lindex $expiryeptitle $i] !=""} {
					if {[lindex $expirydescr $i] !=""} {
						lappend text "[lindex $expiryeptitle $i] - [lindex $expirydescr $i]"
					} else {
						lappend text "[lindex $expiryeptitle $i]"
					}
				} else {
					if {[lindex $expirydescr $i] !=""} {
						lappend text "[lindex $expirydescr $i]"
					} else {
						lappend text "No description."
					}
				}
				
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint expire 007"}
			
				if {$dmailLinksOn} {
					lappend text "</td><td class=links>"
					lappend text "<a href=\"$dmailTivoURL/editprogram/[lindex $expiryfsid $i]\" target=\"_blank\">edit recording</a><br>"
					lappend text "<a href=\"$dmailTivoURL/showing/[lindex $expiryshowingfsid $i]\" target=\"_blank\">view details </a>"
				}			
				lappend text "</td></tr>"				
				
				if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-item text added."}
				set runningcount [expr $runningcount + 1]
			}
			
			set i [expr $i + 1]
		
		}
		if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-second loop completed."}
		
		lappend message $text
		
		set nowsecs [expr $nowsecs + 86400]
		if {$yankspeak} {
			set nowday [clock format [expr $nowsecs +  $tzoffset - $listseperatoroffset] -format {%A, %B %d}]
		} else {
			set nowday [clock format [expr $nowsecs  + $tzoffset - $listseperatoroffset] -format {%a, %d %b}]
		}
		if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-day augmented"}
		
	}
	
	if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-first loop completed"}
	

	unset text
	unset expirytitle
	unset expiryrectime
	unset expiryexpsecs
	unset expiryeptitle
	unset expirydescr
	unset expiryfsid
	unset expiryshowingfsid
	unset expirycount 

	
	return $message

}


##############################################################
## adapted from the phone.itcl module by Courtney Bailey

proc phone_status {} {

	global db
	global version3
	global debuglvl
	
	set errormessages { "Blank" "Succeeded" "PendingRestart" \
		"InitializationFailure" "SettingUp" "InProgress" \
		"UnknownError" "Failure during Housekeeping" \
		"Failure during Preparation" "Failed. Line unavailable" \
		"Failed. No dial tone" "Failed. Couldn't dial" "Failed. Wrong number" \
		"Failed. Service is not answering" "Failed. Service unavailable" \
		"Failed. Service denied" "Failed. Call interrupted" \
		"Failed while expanding data" "Failed while preparing data" \
		"Failed while loading series" "Failed while indexing shows" "Failed to set clock" \
		"Failed getting account status" "Failure downloading messages" "Failed. Phone is busy" \
		"Failed while indexing days" "Failed getting account status" "In Progress" \
		"Housekeeping" "Preparing to call" "Dialing..." "Answering..." "Answered" \
		"Connecting..." "Getting account status" "Setting clock..." "Downloading messages" \
		"Processing..." "Downloading..." "Hanging up" "Expanding data" "Preparing data" \
		"Loading data" "Indexing series" "Indexing shows" "Indexing days" \
		"Failed. Modem is not responding" "Configuring modem" "Failed. No dial-in number chosen." \
		"Finishing up..." }

	if {$::version3} {
		set config "/State/PhoneConfig"
		set serviceinfo $config
	} else {
		set config "/Setup"
		RetryTransaction {
			set configdir [db $db open $config]
			set serviceinfo [dbobj $configdir get ServiceInfo]
			unset configdir
		}
	}

	RetryTransaction {
		set configdir [db $db open $config]

		if {$::version3} {
			set serviceinfo $configdir
		} else {
			set serviceinfo [dbobj $configdir get ServiceInfo]
		}

		set lastcallstatus [dbobj $configdir get LastCallStatus]
		
		if { $lastcallstatus == "Failed"} {
			set csi [dbobj $serviceinfo get CallStatusInfo]
			if {$csi != "Failed" } {
				regexp {[0-9]+} $csi lastcallstatus
				set lastcallstatus [lindex $errormessages $lastcallstatus]
			}
			return $lastcallstatus
		} else {
			set lastcallstatus "Ok"
			return $lastcallstatus
		}
		unset configdir
	}
}


###################################################################
## Define stylesheet by Milhouse - version 2 2 - POST #364
##

proc outputStyleSheet {chan} {
	global debuglvl
	puts $chan "<style type='text/css'>"
	puts $chan "body"
	puts $chan "{"
	puts $chan "	margin: 10px 0px 0px 10px;"
	puts $chan "	font-size: 14px;"
	puts $chan "	font-family: Arial,helvetica,sans-serif;"
	puts $chan "	background-color: #ffffff;"
	puts $chan "	cursor: default;"
	puts $chan "}"
	puts $chan "a"
	puts $chan "{"
	puts $chan "	color: #305BB9;"
	puts $chan "}"
	puts $chan "table"
	puts $chan "{"
	puts $chan "	padding: 0px;"
	puts $chan "	margin: 0px;"
	puts $chan "}"
	puts $chan "table.indented"
	puts $chan "{"
	puts $chan "	margin-left: 32px;"
	puts $chan "}"
	puts $chan "table.section"
	puts $chan "{"
	puts $chan "	padding: 0px;"
#	puts $chan "	width: 807px;"
	puts $chan "	margin: 0px 0px 0px 32px;"
	puts $chan "	background-color: #cccccc;"
	puts $chan "	border-collapse: collapse;"
	puts $chan "}"
	puts $chan "td.programme"
	puts $chan "{"
	puts $chan "	font-size: 14px;"
	puts $chan "	width: 675px;"
	puts $chan "	background-color: #cccccc;"
	puts $chan "	border-bottom: 2px solid #ffffff;"
	puts $chan "}"
	puts $chan "td.seperator"
	puts $chan "{"
	puts $chan "	font-size: 15px;"
	puts $chan "	color: #305BB9;"
	puts $chan "	width: 675px;"
	puts $chan "	background-color: #cccccc;"
	puts $chan "	border-bottom: 2px solid #ffffff;"
	puts $chan "}"
	puts $chan "td.suggestion"
	puts $chan "{"
	puts $chan "	font-size: 14px;"
	puts $chan "	width: 675px;"
	puts $chan "	background-color: #F8E9E4;"
	puts $chan "	border-bottom: 2px solid #ffffff;"
	puts $chan "}"	
	puts $chan "td.links"
	puts $chan "{"
	puts $chan "	font-size: 12px;"
	puts $chan "	text-align: center;"
	puts $chan "	width: 100px;"
	puts $chan "	border-left: 2px solid #ffffff;"
	puts $chan "	border-bottom: 2px solid #ffffff;"
	puts $chan "}"
	puts $chan "td.thumbs"
	puts $chan "{"
	puts $chan "	font-size: 12px;"
	puts $chan "	text-align: center;"
	puts $chan "	width: 50px;"
	puts $chan "	border-left: 2px solid #ffffff;"
	puts $chan "	border-bottom: 2px solid #ffffff;"
	puts $chan "}"
	puts $chan " .PageHeading"
	puts $chan "{"
	puts $chan "	color: #305BB9;"
	puts $chan "	font-size: 18px;"
	puts $chan "	font-weight: bold;"
	puts $chan "}"
	puts $chan " .SectionHeading"
	puts $chan "{"
	puts $chan "	color: #305BB9;"
	puts $chan "	font-size: 16px;"
	puts $chan "	font-weight: bold;"
	puts $chan "}"
	puts $chan " .Warning"
	puts $chan "{"
	puts $chan "	color: #952B42;"
	puts $chan "	font-size: 14px;"
	puts $chan "	font-weight: bold;"
	puts $chan "}"
	puts $chan " .Normal"
	puts $chan "{"
	puts $chan "	font-size: 14px;"
	puts $chan "}"
	puts $chan " .Message"
	puts $chan "{"
	puts $chan "	font-size: 14px;"
	puts $chan "	color: #952B42;"
	puts $chan "	background-color: #FFFFCC;"
	puts $chan "}"
	puts $chan "</style>"
}

##############################################################
# Output the specified section

proc outputSection {index} {
	global dmailHoursahead
	global dmailToDoList
	global dmailConflicts
	global dmailExpired
        global dmailTivoStatus
        global dmailRecHistory
       	global debuglvl
       	global yankspeak
        global tzoffset
        global rejectedrecreq
        
	set sectionHeading ""
	set sectionWithData ""
	set sectionWithoutData ""
	set sectionMessage ""

	if { $dmailToDoList == $index } {
		set sectionHeading "To Do"
		if {$yankspeak} {
			set sectionWithData "The following programs are scheduled to record in the next $dmailHoursahead hours: "
		} else {
			set sectionWithData "The following programmes are scheduled to record in the next $dmailHoursahead hours: "		
		}
		set sectionWithoutData "No recordings scheduled in the next $dmailHoursahead hours."
		set sectionMessage [gettodo $dmailHoursahead]
	} elseif { $dmailConflicts == $index } {
		set sectionHeading "Conflicts"
		if {$yankspeak} {
			set sectionWithData "The following unresolvable conflicts occur in the next $dmailHoursahead hours. The TiVo has determined that these programs that you have selected <br>to be recorded via season-pass or wishlist will not be recorded: "
		} else {
			set sectionWithData "The following unresolvable conflicts occur in the next $dmailHoursahead hours. The TiVo has determined that these programmes that you have selected <br>to be recorded via season-pass or wishlist will not be recorded: "
		}
		set sectionWithoutData "No unresolvable conflicts occur in the next $dmailHoursahead hours."
		set sectionMessage [getconflicts $dmailHoursahead]
	} elseif { $dmailExpired == $index } {
		if {$yankspeak} {
			set sectionHeading "Expiration"	
		} else {
			set sectionHeading "Expiry"
		}
		set sectionWithData "The following recordings are due to expire in the next $dmailHoursahead hours: "
		set sectionWithoutData "No recordings are scheduled to expire in the next $dmailHoursahead hours."
		set sectionMessage [getnpexpire $dmailHoursahead]
	} elseif { $dmailTivoStatus == $index } {
		set sectionHeading "Status"
		if {$yankspeak} {
			set sectionWithData "Here is the status of your TiVo status as of <i>[clock format [expr [clock seconds] + $tzoffset] -format {%A, %B %d %I:%M:%S%p}]</i> : "
		} else {
			set sectionWithData "Here is the status of your TiVo status as of <i>[clock format [clock seconds] -format {%a, %d %b %H:%M} -gmt true]</i> : "
		}
		set sectionWithoutData "No status information available."
		set sectionMessage [gettempuptime]
	} elseif { $dmailRecHistory == $index } {
		set sectionHeading "Rejected Recordings"
		if {$yankspeak} {
		
			if {$rejectedrecreq == 0} {
				set sectionWithData "The following programs either were not recorded in the last $dmailHoursahead hours or will not be recorded within the next $dmailHoursahead hours : "
			} elseif {$rejectedrecreq == -1} {
				set sectionWithData "The following programs were not recorded in the last $dmailHoursahead hours : "
			} elseif {$rejectedrecreq == 1} {
				set sectionWithData "The following programs will not be recorded within the next $dmailHoursahead hours : "
			} else {
				set sectionWithData "No rejected recordings list information available."
			}
		} else {
			if {$rejectedrecreq == 0} {
				set sectionWithData "The following programmes either were not recorded in the last $dmailHoursahead hours or will not be recorded within the next $dmailHoursahead hours : "
			} elseif {$rejectedrecreq == -1} {
				set sectionWithData "The following programmes were not recorded in the last $dmailHoursahead hours : "
			} elseif {$rejectedrecreq == 1} {
				set sectionWithData "The following programmes will not be recorded within the next $dmailHoursahead hours : "
			} else {
				set sectionWithData "No rejected recordings list information available."
			}
		}
		set sectionWithoutData "No rejected recordings list information available."
		set sectionMessage [recordhistory]				
	} else {
		return $sectionMessage
	}

	set formattedMessage ""

	set text "<br><span class=SectionHeading>$sectionHeading</span><br>"
	lappend formattedMessage $text
	
	if {$sectionMessage != ""} {
		set text "$sectionWithData<br>"
		lappend formattedMessage $text

		set text "<br><table class=section>"
		lappend formattedMessage $text
		lappend formattedMessage $sectionMessage
		lappend formattedMessage "</table>"
	} else {
		set text "$sectionWithoutData<br>"
		lappend formattedMessage $text
	}
	return $formattedMessage
}


##################################################################################################################
## Get the temperature, uptime, and apps running
## by PortlandPaw
##

proc gettempuptime {} {
	
	global pslocation
	global debuglvl
	global yankspeak
	global cronloc
	global cronlistrequired
	global verylowtempcentigrade
	global lowtempcentigrade
	global midtempcentigrade
	global hightempcentigrade
	global toohightempcentigrade
	global emergencytempcentigrade

	set text ""
	
	##################################################################################################################
	## get and display daily call information
	## by del4
	##
	
	global tzoffset
	global version3
	global db
	if {$version3} {
		set config "/State/PhoneConfig"
		set suffix "SecInDay"
	} else {
		set config "/Setup"
		set suffix ""
	}
	
	##
	##
	###################################################################################################################
	
	if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-reading the temperature, calculating uptime, checking what's running"}
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-about to run thermal check"}
	set cur_temp [exec cat /proc/therm]
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-thermal check run"}
  	set cur_tempF [expr 1.8*[string trim $cur_temp 'C']+32]F
  	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-about to run uptime check"}
  	set uptime [lindex [exec cat /proc/uptime] 0]
  	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-uptime check run"}
  	set uptime [expr int($uptime)]
  	set uptimestr [format "%d days, %d hours, %02d minutes and %02d seconds" [expr $uptime / 86400] [expr ($uptime % 86400) / 3600] [expr ($uptime % 3600) / 60] [expr $uptime % 60]]
  	set digit_tempC [expr [string trim $cur_temp 'C']]
	if {$digit_tempC < $verylowtempcentigrade} {
		set temp_comment "Running cool -- the case must be open"
	}   elseif {$digit_tempC < $lowtempcentigrade}  {
		set temp_comment "Running in the lower range of normal"
	}   elseif {$digit_tempC < $midtempcentigrade}  {
		set temp_comment "Running in the middle range of normal"
	}   elseif {$digit_tempC < $hightempcentigrade}  {
		set temp_comment "Running in the upper range of normal"
	}   elseif {$digit_tempC < $toohightempcentigrade}  {
		set temp_comment "<b>Starting to run hot!  Watch it!</b>"
	}   elseif {$digit_tempC < $emergencytempcentigrade}  {
		set temp_comment "<b>Your TiVo is running hot!  It should be shut down.</b>"
	}   else {
		set temp_comment "<b>TiVo is way too hot!  Shut it down right NOW!<b>	"
	}
	
	set text "<tr><td class=programme>TiVo temperature is $cur_temp / $cur_tempF ($temp_comment).</td></tr>"
	lappend message $text
	set text "<tr><td class=programme>TiVo has been up for $uptimestr.</td></tr>"
	lappend message $text
	
	
	##################################################################################################################
	## get and display daily call information
	## by del4
	##
	
	RetryTransaction {
		set config [db $db open $config]
		set LSC [dbobj $config get LastSuccessCall$suffix]
		set NSC [dbobj $config get NextCallAttempt$suffix]
	}
	proc GetGuideData { } {
		set count 0
		set lastday 0
		
		after 2000
		
		ForeachMfsFile fsid name type /Schedule "" {
			set date [lindex [split $name ":"] 1]
			if { $date > $lastday } {
				set lastday $date
			}
			incr count
			if { $count >= 100 } {
				return $lastday
			}
		}
		return $lastday
	} 

	set GDT [GetGuideData]
	if {$yankspeak} {
		set LastSuccessfulCall [clock format [expr $LSC + $tzoffset] -format "%A, %B %d at %I:%M%p"]
		set NextScheduledCall [clock format [expr $NSC + $tzoffset] -format "%A, %B %d at %I:%M%p"]
		set GuideDataThrough [clock format [expr $GDT * 86400] -format "%A, %B %d %Y"]
	} else {
		set LastSuccessfulCall [clock format [expr $LSC + $tzoffset] -format "%a, %d %b at %H:%M"]
		set NextScheduledCall [clock format [expr $NSC + $tzoffset] -format "%a, %d %b at %H:%M"]
		set GuideDataThrough [clock format [expr $GDT * 86400] -format "%a, %d %b %Y"]
	}

	set text "<tr><td class=programme>The following daily call information is available:"
	lappend message $text
	set text "<ul style='margin-top:0.1cm; margin-bottom:0cm' type=disc>"
	lappend message $text
	set text "<li>Last successful call: $LastSuccessfulCall</li>"
	lappend message $text
	set text "<li>Next scheduled call: $NextScheduledCall</li>"
	lappend message $text
	set text "<li>Guide data exists through: $GuideDataThrough</li></ul></td></tr>"
	lappend message $text
	set cronactive 0
	
	##
	##
	###################################################################################################################-	
		
	set text "<tr><td class=programme>The following hack applications are currently running on your TiVo:"
	lappend message $text
	set shellcmd "$pslocation"
        if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-about to run ps"}
	set procs [exec $shellcmd ax]
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-ps run"}
	set text "<ul style='margin-top:0.1cm; margin-bottom:0cm' type=disc>"
	lappend message $text
	foreach appname {tnlited httpd-tt.tcl tivoftp mfs_ftp yac tcs cron vserver tserver tyserver tyindex endpad.tcl noreddot.tcl} {
		if [regexp $appname $procs]  {
			if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-hack found >>$appname<<"}
			switch $appname {
				"tnlited" {set appmessage "TiVo Telnet"}
				"tivoftp" {set appmessage "TiVo FTP"}
				"tcs" {set appmessage "TiVo Control Center (TCS)"}
				"httpd-tt.tcl" {set appmessage "TivoWeb"}
				"yac" {set appmessage "YAC Caller ID display"}
				"vserver" {set appmessage "mPlayer server"}
				"tserver" {set appmessage "TyTool"}
				"mfs_ftp" {set appmessage "mfs_ftp"}
				"cron" {set appmessage "cron Scheduler"
					set cronactive 1}
				"tyserver" {set appmessage "TyStudio"}
				"tyindex" {set appmessage "TyIndex"}
				"endpad.tcl" {set appmessage "Endpad"}
				"noreddot.tcl" {set appmessage "No Red Dot"}
			}
			set text "<li>$appmessage</li>"
			lappend message $text
		}
	}
	set text "</ul></td></tr>"
	lappend message $text
	
	
	##################################################################################################################
	## parse cron file and list scheduled tasks
	## by del4
	##
	if {$cronactive && $cronlistrequired} {
		set text "<tr><td class=programme>The following hack applications are scheduled to run on your TiVo:"
		lappend message $text
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-about to parse crontab file"}
		set cronfile [open $cronloc "r"]
		set text "<ul style='margin-top:0.1cm; margin-bottom:0cm' type=disc>"
		lappend message $text
		while { ! [eof $cronfile] } {
			set line [gets $cronfile]
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-line : >>$line<<"}
			foreach cronname {dailymail_jazz.tcl dailymail.tcl tivotitle.tcl rsync endpad.tcl moviesort.tcl} {
				if [regexp $cronname $line] {
					if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-permitted item found in line : >>$cronname<<"}
					if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-about to split cron line into parameter items"}
					set paramlist [split $line " "]
					if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-cron split successfully into individual items"}
					if { [lsearch -glob $paramlist #*] != 0 } {
						if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-this item is valid - not comment"}
						#set paramlist [split $line " "]
						set m [lindex $paramlist 0]
						if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-minute parameter : >>$m<<"}
						set h [lindex $paramlist 1]
						if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-hour parameter : >>$h<<"}
						set dom [lindex $paramlist 2]
						if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-day of month parameter : >>$dom<<"}
						set mon [lindex $paramlist 3]
						if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-month parameter : >>$mon<<"}
						set dow [lindex $paramlist 4]
						if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-day of week parameter : >>$dow<<"}
						if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint 001"}
						
						set m [string trimleft $m 0]
						set h [string trimleft $h 0]
						
						#if { $m == "" } { set m 0 }
						#if { $h == "" } { set h 0 }
						
						if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-hour parameter now : >>$h<<"}
						if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-minute parameter now : >>$m<<"}
						
						
						if { [lsearch -glob $m "*/*"] != -1 } {
						
							if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint 002"}
							set mlist [split $m "/"]
							if { $h == "*" } {
								if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint 003"}
								set schedout "(Every [lindex $mlist 1] minutes)"
							} 
						} elseif { [lsearch -glob $h "*/*"] != -1 } {
							if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint 004"}
							set hlist [split $h "/"]
							if { $m == "*" } {
								if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint 005"}
								set schedout "(Every [lindex $hlist 1] hours)"
							}
						} else {
							if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint 006"}
							
							if {$h == "*"} {
							
								set schedout "(hourly - $m minutes past the hour)"
							
							} else {
							
							
								if {[expr $h+($tzoffset/3600)] < 13} {
									if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint 007"}
									set ampm "AM"
								} else {
									if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint 008"}
									set ampm "PM"
								}
								if {$yankspeak} {
									set schedout "([expr $h+($tzoffset/3600)]:$m$ampm daily)"
								} else {
									set $h [expr $h+($tzoffset/3600)]
									set $h [expr $h + 12]
									if {$ampm=="PM"} { 
										if {$h == 24} {
											set schedout "(00:$m daily)"
										} else {
											set schedout "($h:$m daily)"
										}
									} else {
										if {$h < 10} {
											set schedout "(0$h:$m daily)"
										} else {
											set schedout "($h:$m daily)"
										}
									}
								}
								
							}
								
								
						}
						
					
						
						
						switch $cronname {
							"dailymail_jazz.tcl" {set appmessage "DailyMail $schedout"}
							"dailymail.tcl" {set appmessage "DailyMail $schedout"}
							"tivotitle.tcl" {set appmessage "TiVoTitle $schedout"}
							"rsync" {set appmessage "rsync $schedout"}
							"endpad.tcl" {set appmessage "EndPad $schedout"}
							"moviesort.tcl" {set appmessage "MovieSort $schedout"}
						}
						set text "<li>$appmessage</li>"
						lappend message $text
					} else {
						if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-invalid cron line >>$line<<"}
					}
				}
			}
		}
		set text "</ul></td></tr>"
		
		close $cronfile
		
				
		lappend message $text
	}
	##
	##
	###############################################################################################################################################################################
	
	unset text
	
	return $message
}


##
## END OF PORTLANDPAW'S CODE
#######################################################################################################################################

############################################################################################################################################
## THIS WHOLE SECTION IS LJ'S CODE FOR CHECKING DISK SPACE (From LJ 0.2.1) 
##

proc disk_status {} {
	global debuglvl
	global db
	global drivespacegig
	global usedspacegig
	
	after 2000
	
	ForeachMfsFileTrans fsid name type "/Recording/DiskUsed/10" "" 15 {
		set rec [db $db openid $fsid]
		scan $name "%d:%d" fsid streamsize
		set state [dbobj $rec get State]
		set recquality [dbobj $rec get RecordQuality]
		if {$state == 5} {
			set rectype 102
		} else {
			if {$::version3} {
				set recbeh [dbobj $rec get RecordingBehavior]
				set rectype [dbobj $recbeh get PresentationBehavior]
			} else {
				set rectype [dbobj $rec get SelectionType]
			}
			set expsecs [timedateconv $rec Expiration]
			if {$expsecs < [clock seconds]} {
				set rectype -$rectype
			}
		}

		set recdur [rec_get_dur $rec]
		store_space space time count list $rectype $streamsize $recdur
		if {($::dtivo || $::defrecquality == $recquality) && (!$::version3 || $rectype != 8)} {
			store_space space time count list 103 $streamsize $recdur
		}
		unset rec
	}
	
	after 2000

	ForeachMfsFileTrans fsid name type "/Recording/InProgress" "" 15 {
		set rec [db $db openid $fsid]
		set indexpath [dbobj $rec get IndexPath]
		if {[string match "*LiveCache*" $indexpath]} {
			set parts [dbobj $rec gettarget Part]
			if {$::dtivo} {
				set size [expr [llength $parts] * 256 * 1024] 
			} else {
				set size [expr [llength $parts] * 204 * 1024] 
			}
			set secs [expr round($size / (5960000.0/8/1024))]
			store_space space time count list 100 $size $secs
		} else {
			set parts [dbobj $rec get Part]
			set size [expr [llength $parts] * 512 * 1024] 
			set secs 0
			foreach part $parts {
				set begin [dbobj $part get Begin]
				set end [dbobj $part get End]
				if {$end != "" && $begin != ""} {
					set diff [expr ($end - $begin)/1000]
					incr secs $diff
				}
			}
			store_space space time count list 101 $size $secs
		}
		unset rec
	}

	if {[info exists space]} {

		set list [lsort -integer $list]
		set tcount 0
		set tspace 0
		set ttime 0

		foreach type $list {
			if {$type < 102} {
				# disp_spacerow $chan [get_type $type] $count($type) [expr $space($type)/1024] [timeconv $time($type)] $::usersize ""
				incr tcount $count($type)
				incr tspace $space($type)
				incr ttime  $time($type)
			}
		}
	}
	
if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-actual space free = [expr round($tspace / ( 1024 * 1024 ) )] gig"}
if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-actual space on disks = [ expr round($::usersize / 1024 )] gig"}
if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-actual % used = [expr round(($tspace / 1.024 )/$::usersize) / 10.0]%"}
	
	set usedspacegig [expr round($tspace / ( 1024 * 1024 ) )]
	set drivespacegig [ expr round($::usersize / 1024 )]

  	return [expr round(($tspace / 1.024 )/$::usersize) / 10.0]
}


proc timedateconv {obj what} { 
	return [expr [dbobj $obj get ${what}Date]*86400+[dbobj $obj get ${what}Time]]
}          


proc timeconv {time} {
	return [format "%d:%02d:%02d" [expr ($time/(60*60))] [expr ($time/60)%60] [expr $time%60]]
}


proc get_type {type} {
	global selectiontypes
	global presentationbehtypes
	if {$type == 100} {
		set name "Live Cache"
	} elseif {$type == 101} {
		set name "In Progress"
	} elseif {$type == 102} {
		set name "(Deleted Shows)"
	} else {
		if {$type < 0} {
			set name "Expired "
			set type [expr abs($type)]
		} else {
			set name ""
		}
		if {$::version3} {
			set name "$name[strim [lindex $presentationbehtypes [expr $type - 1]]]"
		} else {
			set name "$name[strim [lindex $selectiontypes [expr $type - 1]]]"
		}
	}
	return $name
}


proc rec_get_dur {rec} {
	set objtype [dbobj $rec type]
	if {$objtype == "VideoClip"} {
		return 0
	}
	set showing [dbobj $rec get Showing]
	set stopdate [dbobj $rec get StopDate]
	set stoptime [dbobj $rec get StopTime]
	if { $stoptime == "" } {
		set stoptime [expr ([dbobj $showing get Time] + [dbobj $showing get Duration]) % 86400]
	}
	set startdate [dbobj $rec get StartDate]
	set starttime [dbobj $rec get StartTime]
	if { $starttime == "" } {
		set starttime [dbobj $showing get Time]
	}
	if { $stopdate != "" } {
		set durationsecs [expr ($stopdate * 86400 + $stoptime) - ($startdate * 86400 + $starttime)]
	}
	set showingdurationsecs [dbobj $showing get Duration]
	if { $durationsecs == 0 } {
		set durationsecs $showingdurationsecs
	}
	return $durationsecs
}


proc store_space {spacevar timevar countvar listvar rectype streamsize rectime} {
	upvar $spacevar space
	upvar $timevar time
	upvar $countvar count
	upvar $listvar list
	if {[info exists space($rectype)]} {
		incr space($rectype) $streamsize
		incr time($rectype) $rectime
		incr count($rectype)
	} else {
		lappend list $rectype
		set space($rectype) $streamsize
		set time($rectype) $rectime
		set count($rectype) 1
	}
}


proc get_totalsizes {} {
	global tivowebdir
	global usersize reservedsize

	set retval [catch {set getspace [exec "$tivowebdir/get_space"]} error]
	if {$retval != 1} {
		scan $getspace "%*d %*d %d %*d" totalmedia
	} else {
		error $error
	}
	if {$::uktivo} {
		if {$totalmedia > 90000000} {
			set reservedsize [expr round(20000000/2/1024)]
		} else {
			set reservedsize [expr round(($totalmedia - 65314816)/2/1024)]
		}
	} elseif {$::dtivo} {
		if {$totalmedia > 120000000} {
			set suffix [string range $::tivoswversion [expr [string length $::tivoswversion] - 3] end]
			if {$suffix == "011"} {
				set reservedsize [expr round(22217032/2/1024)]
			} else {
				set reservedsize [expr round(20000000/2/1024)]
			}
		} else {
			set reservedsize [expr round(($totalmedia - 70586800)/2/1024)]
		}
	} elseif {[PrefixMatches "3.2" $::tivoswversion]} {
		set reservedsize [expr round(9421824/1024)]
	} else {
		if {$totalmedia > 120000000} {
			set reservedsize [expr round(10000000/1024)]
		} elseif {$totalmedia > 105000000} {
			set reservedsize [expr round(($totalmedia/2 - 48201728)/1024)]
		} elseif {$totalmedia > 90000000} {
			set reservedsize [expr round(4194304/1024)]
		} elseif {$totalmedia > 60000000} {
			set reservedsize [expr round(7127848/1024)]
 		} elseif {$totalmedia > 35000000} {
			set reservedsize [expr round(2933760/1024)]
		} else {
			set reservedsize [expr round(423936/1024)]
		}
	}
	set usersize [expr round($totalmedia/2/1024) - $reservedsize]
}

##
## END OF LJ'S DISK CHECKING CODE (From LJ 0.2.1) 
#############################################################################################################################


#############################################################################################################################
## START OF LJ's MAIL CHECK CODE (From LJ 0.2.1) 
## Slightly modified just to indicate whether you have mail or not

proc checkmail {} {
	global db
	global tzoffset
	global debuglvl

	set showdeleted ""
	set gotmail false
	set now     [clock seconds]
	set nowdate [expr $now / 86400]
	set nowtime [expr $now % 86400]
	
	after 2000
	
	foreach section {PreTivoCentral MessageBoard} {
		ForeachMfsFileTrans fsid name type "/MessageItem/$section" "" 20 {
			set msg [db $db openid $fsid]
			set dateread [dbobj $msg get DateRead]
			if {$dateread == ""} {
				set from [htmlEncode [dbobj $msg get From]]
				set subject [htmlEncode [dbobj $msg get Subject]]
				set body [htmlEncode [dbobj $msg get Body]]
				set date [dbobj $msg get DateGenerated]
				set time [dbobj $msg get TimeGenerated]
				set seconds [expr $date * 86400 + $time + $tzoffset]
				if {$::uktivo} {
					set daystr [nth [clock format $seconds -format "%e"]]
					set datestr [clock format $seconds -format "%a $daystr %b %Y"]
				} else {
					set datestr [clock format $seconds -format "%1m/%1d"]
				}
				set expdate [dbobj $msg get ExpirationDate]
				set expsecs [expr $expdate * 86400 + $tzoffset]
				if {$::uktivo} {
					set daystr [nth [clock format $expsecs -format "%e"]]
					set expdatestr [clock format $expsecs -format "%a $daystr %b %Y"]
				} else {
					set expdatestr [clock format $expsecs -format "%1m/%1d"]
				}
				set deleted [dbobj $msg get Deleted]
				dbobj $msg set DateRead $nowdate
				dbobj $msg set TimeRead $nowtime
				set gotmail true
			}
			unset msg
		}
  	}
  	return $gotmail
}

proc htmlEncode { text } {
	set ret "$text"
	regsub -all "\&" $ret {\&amp;} ret
	regsub -all "<" $ret {\&lt;} ret
	regsub -all ">" $ret {\&gt;} ret
	regsub -all "\n" $ret {<BR>} ret
	return "$ret"
}

##
## END OF LJ's MAIL CHECK CODE (From LJ 0.2.1) 
#############################################################################################################################


##############################################################################################################################
## HISTORY code from ui.itcl file - for record list
##

proc recordhistory {} {
	
	global db
	global tzoffset
	global debuglvl
	global recmintime
	global recmaxtime
	global dmailHoursahead
	global yankspeak
	global afterbefore
	global listseperator
	global listseperatoroffset
	global rejectedrecreq
	global cancelreasons
	
	set text ""
	set message {}
	
	set cancelreasons "SwitchToLiveTv RecordDifferentShowing StayOnLiveTv InternalError PowerWasOff Expired GotBetterSuggestion DemoMode UnexpectedConflict UserRequestedRecording UserRequestedSeasonPass ExplicitlyDeleted ChannelLineupChanged ProgramGuideChanged RecorderEmergency UserCancelledSeasonPass FuzziesTurnedOff FuzzyStoppedEarly Unknown ProgramSourceConflict ConvertedLiveCache LiveCacheOnlySuccessful ProgramSourceDiskConflict ExplicitlyDeletedFromToDo ProgramSourceModified NotAuthorized NoReRecord NoSignal MaxRecordingsExceeded CaptureRequestExpired NoSignalTunerOne NoSignalTunerTwo MaxRecordingsNowShowing VideoMgrDeniedTuner"

	
	if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-started record history procedure"}
	
	set now [clock seconds]
	set oldday ""
  
  	if { $rejectedrecreq == -1 || $rejectedrecreq == 0 } {
 		set mintime [expr $now - $dmailHoursahead * 3600]
 	} else {
 		set mintime $now
 	}
 	if { $rejectedrecreq == 1 || $rejectedrecreq == 0 } {
		set maxtime [expr $now + $dmailHoursahead * 3600]
	} else {
		set maxtime $now
	}
	
	set afterbefore true
	set werebefore false
  
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-mintime >>$mintime<<"}
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-maxtime >>$maxtime<<"}

	after 2000

	if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-about to query database for recording history"}
	ForeachMfsFile fsid name type "/Recording/History" "" {
		if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint #1 - inside db loop"}
		set recdate [split $name ":"]
		if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint #2 - after set recdate"}
		regsub {^(-?)0+([1-9])} [lindex $recdate 1] {\1\2} rectime
		if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint #3 - after regsub"}
		set rectime [expr [lindex $recdate 0] * 86400 + $rectime]
		if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint #4 - after set rectime"}
		if {$rectime > $mintime && $rectime < $maxtime} {
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint #5 - inside rectime conditional loop"}
			RetryTransaction {
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint #6 - inside retrytransaction area"}
				set rec [db $db openid $fsid ]
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint #7 - after set rec"}
				set creason [dbobj $rec get CancelReason]
				set showing [dbobj $rec get Showing]
				set showingfsid [dbobj $rec gettarget Showing]
				set startdate [dbobj $rec get StartDate]
				set starttime [dbobj $rec get StartTime]
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint #8 - after rec oriented variable setting"}
				set station [dbobj $showing get Station]
				set program [dbobj $showing get Program]
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint #9 - after showing oriented variable setting"}
				set stationfsid [dbobj $station fsid]
				set callsign [dbobj $station get CallSign]
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint #10 - after station oriented variable setting"}
				set title [strim [dbobj $program get Title]]
				set descr [strim [dbobj $program get Description]]
				set id [dbobj $program get TmsId]
				set id2 [dbobj $program fsid]
				set series [dbobj $program get Series]
				set isEpisode [defaultval 0 [dbobj $program get IsEpisode]]
				
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint #11 - after core variable setting"}
				
				if {$yankspeak} {
					set nowday [clock format [expr $rectime+  $tzoffset - $listseperatoroffset] -format {%A, %B %d}]
				} else {
					set nowday [clock format [expr $rectime + $tzoffset - $listseperatoroffset] -format {%a, %d %b}]
				}
				
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint #12 - after nowday variable setting"}
				
				if {$series != ""} {
					set episodic [defaultval 1 [dbobj $series get Episodic]]
				} else {
					set episodic 1
				}
				
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint #13 - after series definition"}
				
				if { $episodic == 1 } {
					set eptitle [strim [dbobj $program get EpisodeTitle]]
				} else {
					set eptitle ""
				}
				
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint #14 - after episode definition"}
				
				unset rec
			}
			
			set reason ""
			set altshow ""
			set alt ""
			
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint #15 - after additional variable stup"}
			
			set findalt 0
			
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint #16 - prior to creason switch"}
			
			switch $creason {
				2 { set reason "Duplicate" }
				5 { set reason "Power Was Off" ; set findalt 1 }
				12 { set reason "Deleted" }
				14 { set reason "No Longer In Program Guide" ; set findalt 1 }
				16 { set reason "Cancelled Season Pass" }
				10 -
				20 {
					set reason "Conflict"
					set findalt 1
				}
				23 { set reason "Not Enough Space" }
				24 { set reason "Cancelled Recording" }
				25 { set reason "Season Pass Modified" }
				default { set reason [lindex $cancelreasons [expr $creason - 1]] }
			}
			
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint #17 - after creason switch"}
		
			if { $reason == "Duplicate" || $reason == "Conflict" ||  $reason == "Power Was Off" } {
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint #18 - inside duplicate, confict or power-off conditional area"}
				if {$isEpisode && $id != ""} {
					if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint #19"}
					set alt [alt_showing_hist $id $id2]
					if {$alt != ""} {
						if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint #20"}
						set altid [lindex $alt 1]
						set altstarttime [lindex $alt 2]
						if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint #21"}
						if {$yankspeak} {
							set altformattedstarttime [clock format [expr $altstarttime + $tzoffset] -format {%A, %B %d %I:%M%p}]
						} else {
							set altformattedstarttime [clock format [expr $altstarttime + $tzoffset] -format {%a, %d %b %H:%M}]
						}	
					
						if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checkpoint #22"}

						if {$altid != ""} {
							if {[lindex $alt 0] == "nowshowing"} {

								if {$rectime > $mintime && $rectime < $now} {
																
									## we need to check if the recorded version was recorded before or after now?
									
									if {$rectime > $altstarttime } {
									
										## so the program in now showing was already recorded
										
										if {$altstarttime < $mintime } {
													
											## way in the past sometime
											set altshow "was already recorded in the past ($altformattedstarttime)."
										
										} else {
										
											## in the recent paset - between now and then
											set altshow "was already recorded ($altformattedstarttime)."
													
										}
										
									} else {
									
										## so the programme in now showing was recorded afterwards
										
										set altshow "was recorded at a later time ($altformattedstarttime)."
									}
									
		
								} else {
								
								
									## we need to check if the recorded version was recorded before or after now?
									
									if {$rectime > $altstarttime } {
									
										## so the program in now showing will have been already recorded
									
										if {$altstarttime < $mintime} {
										
											## in the past sometime
											set altshow "has already been recorded in the past ($altformattedstarttime)."
											
										} elseif  {$altstarttime < $now} {	
											
											## in the recent past sometime
											set altshow "has already been recorded ($altformattedstarttime)."
										
										} else {
										
											## in the very recent past - between now and then
										
											set altshow "will already have been recorded ($altformattedstarttime)."
										
										}
																		
										

										
									} else {
									
										## so the programm in now showing was recorded afterwards
										
										set altshow "is scheduled to record at a later time ($altformattedstarttime)."
									}		
								}
							} else {
							
						
								if {$rectime > $mintime && $rectime < $now} {
																
									
									if {$altstarttime < $maxtime } {
												
										## in the future sometime
										set altshow "was scheduled to record at a future time ($altformattedstarttime)."
										
									} else {
										
										## in the recent paset - between now and then
										set altshow "was scheduled to record at a later time ($altformattedstarttime)."
													
									}									
									

								} else {
								
									if {$altstarttime < $maxtime } {
												
										## in the future sometime
										set altshow "is scheduled to record at a future time ($altformattedstarttime)."
										
									} else {
										
										## in the recent paset - between now and then
										set altshow "is scheduled to record at a later time ($altformattedstarttime)."
													
									}
									
								}
							}
						}
					}
				}
	
			}
			
			set text {}
			
			### start blank date row insert 
			if {$listseperator} {
				if {$oldday != $nowday} {
					lappend text "<tr><td class=seperator>$nowday</td>"
					lappend text "</tr>"			
					set oldday $nowday
				}
			} else {
				
				########################################################################################
				## This section puts a blank row in the table when moving from before now to after now
				
				if {$afterbefore && $rectime >= $now && $werebefore} {
					lappend text "<tr><td class=seperator>&nbsp;</td></tr>"
					set afterbefore false
				}
				if {$rectime < $now} {
					set werebefore true
				}
			
				##
				#########################################################################################
			}	
			### end blank date row insert
			
			lappend text "<tr><td class=programme><strong>"
			lappend text "$title" 
			lappend text "</strong>"
	
			if {$yankspeak} {
				lappend text " [clock format [expr $rectime + $tzoffset] -format {%a %I:%M%p}] $callsign"			
			} else {
				lappend text " [clock format [expr $rectime + $tzoffset] -format {%a %H:%M}] $callsign"
			}
			
			if {$reason != ""} {
				lappend text " ($reason)"
			}
				
			if {$eptitle != ""} {
				lappend text "<br>"
				if {$altshow != ""} {
					lappend text "The episode '$eptitle'"							
					lappend text " $altshow"
				} else {
					lappend text "$eptitle"											
				}
			} else {
				
				if {$altshow != ""} {
										
					if {$yankspeak} {
						lappend text "<br>The program"
					} else {
						lappend text "<br>The programme"
					}
					
					lappend text " $altshow"
				} 
			}
			lappend text "</td></tr>"
			lappend message $text	
		}
	}
  
  	if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-completed record history procedure"}

	unset text

	return $message
}


##########################################
# Copyright (c) 2002 Aaron Schrab <aaron@schrab.com>
proc alt_showing_hist {tofind_tmsid tofind_fsid} {
	global debuglvl
	if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-started alt_showing module"}
	global db
	

	set showings [get_programshowings $tofind_fsid 1]
	
	if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-alt_showing checkpoint #1"}
	
	foreach showing $showings {
	
		if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-alt_showing checkpoint #2 - inside foreach showing"}
		
		set seconds [lindex $showing 0]
		set stationfsid [lindex $showing 1]
		set date [expr $seconds / 86400]
		set time [expr $seconds % 86400]
		set timestr [format "%05d" $time]
		
		if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-alt_showing checkpoint #3 - after variable initialisation"}
		
		after 500
		
		ForeachMfsFile recfsid name type "/Recording/Active" "4:$date:$timestr:" {
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-alt_showing checkpoint #4 - inside db query loop"}
			RetryTransaction {
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-alt_showing checkpoint #5 - inside retrytransaction area"}
				set rec [db $db openid $recfsid]
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-alt_showing checkpoint #6 - after set rec"}
				set show [dbobj $rec get Showing]
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-alt_showing checkpoint #7 - after set show"}
				set starttime [expr [dbobj $show get Date] * 86400 + [dbobj $show get Time]]
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-alt_showing checkpoint #8 - after set starttime"}
				set prog [dbobj $show get Program]
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-alt_showing checkpoint #9 - after set prog"}
				set id [dbobj $prog get TmsId]
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-alt_showing checkpoint #10 - after set id"}
				if {$id == $tofind_tmsid} {
					if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-alt_showing checkpoint #11 - inside id area"}
	 				return "todo [dbobj $show fsid]/[dbobj $show subobjid] $starttime"
				}
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-alt_showing checkpoint #12"}
				unset rec
			}
		}
	}
	
	if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-alt_showing checkpoint #13 = before now showing check"}

	# Also check if it's in Now Showing
	
	after 500
	
	ForeachMfsFile recfsid name type  "/Recording/TmsId" "$tofind_tmsid:" {
		if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-alt_showing checkpoint #14 - inside db query loop"}
		RetryTransaction {
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-alt_showing checkpoint #15 - inside retrytransaction area"}
			set rec [db $db openid $recfsid]
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-alt_showing checkpoint #16 - after set rec"}
			set show [dbobj $rec get Showing]
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-alt_showing checkpoint #17 - after set show"}
			set starttime [expr [dbobj $show get Date] * 86400 + [dbobj $show get Time]]
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-alt_showing checkpoint #18 - after set starttime"}
			return "nowshowing [dbobj $show fsid]/[dbobj $show subobjid] $starttime"
			if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-alt_showing checkpoint #19"}
			unset rec
		}
		if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-alt_showing checkpoint #20"}
	}

	if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-alt_showing checkpoint #21 - end"}
  	return ""
  
}



##
##
#############################################################################################################################


	####################################################################################################################
	# main code
	
	# open the MFS database
	global db
	set db [dbopen]
	
	
	## LJ 0.2.1: Start of extra code to work out sw version; whether in UK; if on a DTiVo
	## WE NEED THIS BECAUSE IT ALSO DEFINES THE DTIVO VARIABLE WHICH IS REQUIRED IN THE SPACE CALCULATION
	
	global tivoswversion
	global dtivo
	
	if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-about to start version setting"}
	
	RetryTransaction {
		set swsystem [db $db open /SwSystem/ACTIVE]
		set tivoswversion [dbobj $swsystem get Name]
		unset swsystem
		
		set setup [db $db open /Setup]
		
		set version 3
	
		if { [string range $tivoswversion 0 2] >= 3.0 } {
			set version3 1
			set version 3
		} else {
			set version3 0
		}
	
		if {[PrefixMatches "2.5.5" $tivoswversion]} {
			set uktivo 1
			set version 2.5
		} else {
			set uktivo 0
		}
	
		set suffix [string range $tivoswversion [expr [string length $tivoswversion] - 3] end]
		if { [lsearch "001 011 031 151" $suffix] >= 0 } {
			set dtivo 1
			set version 3
		} else {
			set dtivo 0
		}
	}
	
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-version3 : >>$version3<<" }
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-uktivo : >>$uktivo<<" }
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-dtivo : >>$dtivo<<" }
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-version (for tivowebplus) : >>$version<<" }
	
	if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-completed version setting" }
	
	## LJ 0.2.1: End of extra code to work out sw version; whether in UK; if on a DTiVo
		
	# call procedures in TiVoWeb to do the heavy lifting
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-about to  include util.itcl"}
	source $tivowebdir/util.itcl
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-util.itcl included - about to include index.itcl"}
	source $tivowebmodulesdir/index.itcl
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-index.itcl included"}
	
	##### LJ'S ADDITION (FROM LJ 0.2.1)
	
	
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-about to identify default recording quality information for space calculations"}
	
	if {$version3 == 1} {
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-version 3 specific code"}
		RetryTransaction {
			if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-transaction attempt"}
			set avconfig [db $db open /State/AvConfig]
			if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-db open successfully"}
			set defrecquality [defaultval 100 [dbobj $avconfig get RecordQuality]]
			#set service [db $db open /State/ServiceConfig]
			#set datagroup [dbobj $service get DataGroupList]
			unset avconfig
		}
	} else {
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-non version 3 specific code"}
		RetryTransaction {
			if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-transaction attempt"}
			set setup [db $db open /Setup]
			if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-db open successfully"}
			set defrecquality [defaultval 100 [dbobj $setup get RecordQuality]]
			#set service [dbobj $setup get ServiceInfo]
			#set datagroup [dbobj $service get DataGroupList]
			unset setup
		}
	}
	
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-about to set source directory."}
	global tivowebdir
	
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-about to call get sizes module."}
	get_totalsizes 
       
	####### END OF LJ'S ADDITION (FROM LJ 0.2.1)

	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-about to set the now showing directory"}
	if {$version3 == 1} {
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-version 3 specific code"}
		set nowshowingdir "/Recording/NowShowingByClassic"
	} else {
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-non version 3 specific code"}
		set nowshowingdir "/Recording/NowShowing"
	}
	
	# set timezone offset
	
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-about to establish timezone offset"}
	
	RetryTransaction {
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-transaction attempt"}
		if {$version3 == 1} {
			if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-version 3 specific code"}
			set lconfig  [db $db open /State/LocationConfig]
			if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-db open successfully"}
			set setup [db $db open /State/ServiceConfig]
			if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-db open successfully"}
			set tz [dbobj $lconfig get TimeZoneOld]
			set summertime [dbobj $lconfig get DaylightSavingsPolicy]
			unset lconfig
			unset setup
		} else {
			if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-non version 3 specific code"}
			set setup [db $db open /Setup]
			if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-db open successfully"}
			set tz [dbobj $setup get TimeZone]
			set summertime [dbobj $setup get DaylightSavingsPolicy]
			unset setup
		}
		if {$tz == ""} {
			set tz 0
		}
		if {$summertime == ""} {
			set summertime 2
		}
	}
	set tzoffset [get_tzoffset $tz $summertime]
	
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-identified time zone offset : >>$tzoffset<<"}
	
	# Assemble e-mail
	set message {}
	
	if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-about to assemble e-mail" }
	
	########################################################
	## create heading
	
	if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-creating heading" }
	
	set text "<table width=\"580\" border=\"0\"> <tr>"
	lappend message $text
	
	if {$graphicson} {
		set text "<td width=\"72\"><img src=\"$dmailGraphicsURL/$tivologofilename\"></td>"
		lappend message $text
	}
	set text "<td width=\"508\" class=PageHeading>Welcome To Your TiVo Status E-Mail For [clock format [clock seconds] -format %A]</td>"
	lappend message $text

	set text "</tr></table>"
	lappend message $text
	
	if {$graphicson} {
		# null
	} else {
		set text "<br>"
		lappend message $text
	}
	
	if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-heading created"}
	
	## Heading created
	########################################################
	
	
	########################################################
	## Optional Message
	
	if { [ lindex $optionalmsg 0 ] != ""} {
	
		if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-creating optional message"}
	
		set text "<table width=\"450\" border=\"0\"class=Indented><tr>"
		lappend message $text
		
		if {$graphicson} {
			set text "<td width=\"80\" class=Message><center><img src=\"$dmailGraphicsURL/$optionalmessagefilename\" border=\"0\"></center></td><td width=\"370\" class=Message>"
			lappend message $text
		} else {
			set text "<td width=\"450\" class=Message>"
			lappend message $text
		}
		
		foreach item $optionalmsg {
			if { $item != "" } {
				lappend message $item
				lappend message "<br>"
			}
		}
		
		set text "</td></tr></table><br>"
		lappend message $text
		
		if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-optional message created"}
	
	}
	
	## End Optional Message
	########################################################
	
	if {$graphicson} {
		set text "<br>"
		lappend message $text
	} 
	
	set text "<table width=\"600\" border=\"0\" class=indented>"
	lappend message $text
	
	
	####################################################
	# how long since last reboot
	
	if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-calculating uptime & reboot status"}
	set uptime [lindex [exec cat /proc/uptime] 0]
	
	if {$bulletinverbose || $uptime < 86400} {
	
		if {$graphicson} {
			if {$dmailLinksOn} {
				set text "<tr><td width=\"80\"><center><a href=\"$dmailTivoURL/info/\"><img src=\"$dmailGraphicsURL/$rebootfilename\" border=\"0\" alt=\"Click&nbsp;here&nbsp;to&nbsp;view&nbsp;more&nbsp;TiVo&nbsp;Information.\" ></a></center></td>"
				lappend message $text
			} else {
				set text "<tr><td width=\"80\"><center><img src=\"$dmailGraphicsURL/$rebootfilename\" border=\"0\"></center></td>"
				lappend message $text
			}
			set text "<td width=\"520\""
			lappend message $text
		} else {
			set text "<tr><td width=\"600\""
			lappend message $text
		}
		
		if {$uptime < 86400} {
			set text " class=Warning>WARNING: The TiVo has rebooted within the last 24 hours."
			lappend message $text
		} else {
			set text " class=Normal>The TiVo has not rebooted within the last 24 hours."
			lappend message $text
		}
		
		if {$graphicson} {
			# null
		} else {
			set text "<br><br>"
			lappend message $text
		}
		
		set text "</td></tr>"
		lappend message $text
	}
	
	
	########################################################################
	## EMERGENCY TEMPERATURE GUAGE SECTION
	
	if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checking for emergency temperature reading"}
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-about to run temperature check"}
	set cur_temp [exec cat /proc/therm]
	if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-temperature check run successfully"}
	set digit_tempC [expr [string trim $cur_temp 'C']]
	set cur_tempF [expr 1.8*[string trim $cur_temp 'C']+32]F
	if {$digit_tempC > $hightempcentigrade && $hightempcentigrade != 0} {

	
		if {$graphicson} {
			set text "<td width=\"80\"><center><img src=\"$dmailGraphicsURL/$emergencytempfilename\" border=\"0\" ></center></td>"
			lappend message $text
			set text "<td width=\"520\""
			lappend message $text
		} else {
			set text "<td width=\"600\""
			lappend message $text
		}
				
		
		if { $digit_tempC > $hightempcentigrade} {
		
			set text " class=Warning>WARNING: The TiVo temperature is at high levels - currently $cur_temp / $cur_tempF ! "
			if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-WARNING-temperature is high - currently $cur_temp / $cur_tempF"}
	
		
		} elseif { $digit_tempC > $toohightempcentigrade} {
		
			set text " class=Warning>WARNING: The TiVo temperature is at very high level - currently $cur_temp / $cur_tempF ! Please investigate immediately immediately!"
			if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-WARNING-temperature is too high - currently $cur_temp / $cur_tempF - PLEASE INVESTIGATE!"}
	
	
		} elseif { $digit_tempC > $emergencytempcentigrade} {
		
			set text " class=Warning>WARNING: The TiVo temperature is at dangerous levels - currently $cur_temp / $cur_tempF ! Turn off your TiVo immediately!"
			if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-DANGER termperature is dangerously high - currently $cur_temp / $cur_tempF - TURN OFF MACHINE NOW!"}
	
		}
		
		
		
		lappend message $text
	
		if {$graphicson} {
				#null
			} else {
				set text "<br><br>"
				lappend message $text
			}
			
		set text "</td></tr>"
		lappend message $text
	}
		
	 
	## END TEMPERATURE SECTION
	########################################################################	
	
	
	#####################################################
	# phone status
	
	# phone status
	if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checking phone & daily call status"}
	set phone [phone_status]
	
	if {$bulletinverbose || $phone != "Ok"} {

		if {$graphicson} {
			if {$dmailLinksOn} {
				set text "<td width=\"80\"><center><a href=\"$dmailTivoURL/Phone/\"><img src=\"$dmailGraphicsURL/$phonefilename\" border=\"0\" alt=\"Click&nbsp;here&nbsp;to&nbsp;view&nbsp;further&nbsp;phone&nbsp;information.\" ></a></center></td>"
				lappend message $text
			} else {
				set text "<td width=\"80\"><center><img src=\"$dmailGraphicsURL/$phonefilename\" border=\"0\"></center></td>"
				lappend message $text
			}
			set text "<td width=\"520\""
			lappend message $text
		} else {
			set text "<td width=\"600\""
			lappend message $text
		}
	
		if {$phone != "Ok"} {
			set text " class=Warning>WARNING: Last daily call failed with error of $phone."
			lappend message $text
		} else {
			set text " class=Normal>Last daily call was performed without error."
			lappend message $text
		}
	
		if {$graphicson} {
			#null
		} else {
			set text "<br><br>"
			lappend message $text
		}
		
		set text "</td></tr>"
		lappend message $text
	
	}
	
	###################################################################
	## THE SMART MESSAGE ADDITION PLUS DISK SPACE ADDITION
	##


	## run smart command if required
	
	set errora 0
	set errorb 0
	set passeda 0
	set passedb 0
			
	if { $smartCmd != "" } {

		if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checking S.M.A.R.T. status"}
				
		if { [catch {exec $smartCmd --all /dev/hda } smart1msg]} {
			set errora 1
			set passeda 1
			if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-SMART command did not successfully run on disk A - check path & setup."}
		} else {
			if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-drive A SMART check :"}
			if { [string first "test result: PASSED" $smart1msg] > -1 } {
				set passeda 1
				if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-disk passed SMART check."}
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-********************************************************************************"}
				if {$debuglvl>2} { puts "$smart1msg"}
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-********************************************************************************"}
			} else {		
				if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-disk failed SMART check - details shown here :"}
				if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-********************************************************************************"}
				if {$debuglvl>0} { puts "$smart1msg"}
				if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-********************************************************************************"}
			}
		}

		if {[catch { exec $smartCmd --all /dev/hdb } smart2msg]} {
			set errorb 1
			set passedb 1
			if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-SMART command did not successfully run on disk B - check path & setup - or you do not have a second hard drive."}
		} else {
			if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-drive B SMART check :"}
			if { [string first "test result: PASSED" $smart2msg] > -1 } {
				set passedb 1
				if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-disk passed SMART check."}
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-********************************************************************************"}
				if {$debuglvl>2} { puts "$smart2msg"}
				if {$debuglvl>2} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-********************************************************************************"}
			} else {
				if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-disk failed SMART check - details shown here :"}
				if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-********************************************************************************"}
				if {$debuglvl>0} { puts "$smart2msg"}
				if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-********************************************************************************"}
			}
		}
	}
	
	
	## calculate disk usage
	
	if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-calculating disk usage"}
	
	set thediskstatus [disk_status]
	set rnddiskstatus [ expr round ( $thediskstatus ) ]
	
	## check to see if we need to show bulletin
		
	if {$bulletinverbose || $passeda == 0 || $passedb == 0 || $rnddiskstatus > $highthreshold } {
		
		## always show graphic
		
		if {$graphicson} {
			set text "<tr><td width=\"80\"><center><img src=\"$dmailGraphicsURL/$diskfilename\" border=\"0\"></center></td><td width=\"520\""
			lappend message $text
		} else {
			set text "<tr><td width=\"600\""
			lappend message $text
		}
		
		## sort out message
				
		if { $passeda ==  0 || $passedb == 0 || $rnddiskstatus > $highthreshold } {
				set text " class=Warning>WARNING: "
				lappend message $text
		} else {
				set text " class=Normal>"
				lappend message $text
		}
			
		if { $smartCmd != "" } {
		
			if { $passeda == 0 && $passedb == 0 } {
			
				set text "SMART errors detected on drives A & B - check log. "
				lappend message $text
			
			} elseif { $passeda == 1 && $passedb == 0 } {
			
				set text "SMART errors detected on drive B - check log. "
				lappend message $text
			
			} elseif { $passedb == 1 && $passeda == 0 } {
			
				set text "SMART errors detected on drive A - check log. "
				lappend message $text
			
			} else {
			
				set text "No detectable drive problems. "
				lappend message $text
			}
		
		
		} 
			
		###################################################################
		## DISK SPACE STUFF (FROM LJ 0.2.1)
		
				
		if { $smartCmd != "" } {
			if { $rnddiskstatus > $highthreshold } {
				set text "Usage is high ($thediskstatus%)."
				lappend message $text	
			} else {
				set text "Usage is at $thediskstatus%."
				lappend message $text	
			}
		} else {
			if { $rnddiskstatus > $highthreshold } {
				set text "Drive usage is high ($thediskstatus%)."
				lappend message $text
			} else {
				set text "Drive usage is at $thediskstatus%."
				lappend message $text		
			}
		}
				
		
		if {$graphicson && $spacebarrequired} {
		
			set text "&nbsp;"
			lappend message $text
		
		        if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-building usage diagram"}
 	       
		        set text "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" align=centre width=1%><tr>"
			lappend message $text
		        
		        set lowsize 0
		        set midsize 0
		        set highsize 0
		        set remaindersize 0
		        		        
		        if { $rnddiskstatus >= $midthreshold } {
		        	set lowsize $midthreshold
		        	if { $rnddiskstatus >= $highthreshold } {
		        		set midsize [ expr $highthreshold - $midthreshold ]
		        		if { $rnddiskstatus == 100 } {
		        			set highsize [ expr 100 - $highthreshold ]
		        		} else {
		        			set highsize [ expr $rnddiskstatus - $highthreshold ]
		        		}
		        	} else {
		        		set midsize [ expr $rnddiskstatus - $midthreshold ]
		        	}      	
		        } else {
		        	set lowsize $rnddiskstatus
		        }
		        
		        set remaindersize [ expr 100 - $thediskstatus ]
		        
		        set multipletime $graphiclengthmultiple
		        
		        set lowsize [ expr $lowsize * $multipletime ]
		        set midsize [ expr $midsize * $multipletime ]
		        set highsize [ expr $highsize * $multipletime ]
		        set remaindersize [ expr $remaindersize * $multipletime ]
 	         
			set text "<td width=\"1\"><img src=\"$dmailGraphicsURL/$spacegraphicstart\" border=\"0\" width=\"1\" height=\"12\" vspace=\"0\" hspace=\"0\" alt=\"Drive&nbsp;usage&nbsp;is&nbsp;at&nbsp;$thediskstatus%. Total&nbsp;drive&nbsp;space&nbsp;is&nbsp;$drivespacegig&nbsp;Gb. Actual&nbsp;space&nbsp;used&nbsp;is&nbsp;$usedspacegig&nbsp;Gb.\" ></td>"
			lappend message $text
			
			if { $lowsize > 0 } {
				set text "<td width=\"$lowsize\"><img src=\"$dmailGraphicsURL/$spacegraphiclow\" border=\"0\" width=\"$lowsize\" height=\"12\" vspace=\"0\" hspace=\"0\" alt=\"Drive&nbsp;usage&nbsp;is&nbsp;at&nbsp;$thediskstatus%. Total&nbsp;drive&nbsp;space&nbsp;is&nbsp;$drivespacegig&nbsp;Gb. Actual&nbsp;space&nbsp;used&nbsp;is&nbsp;$usedspacegig&nbsp;Gb.\" ></td>"
				lappend message $text
			} 
		       
			if { $midsize > 0 } {
				set text "<td width=\"$midsize\"><img src=\"$dmailGraphicsURL/$spacegraphicmid\" border=\"0\" width=\"$midsize\" height=\"12\" vspace=\"0\" hspace=\"0\" alt=\"Drive&nbsp;usage&nbsp;is&nbsp;at&nbsp;$thediskstatus%. Total&nbsp;drive&nbsp;space&nbsp;is&nbsp;$drivespacegig&nbsp;Gb. Actual&nbsp;space&nbsp;used&nbsp;is&nbsp;$usedspacegig&nbsp;Gb.\" ></td>"
				lappend message $text
			} 
			
			if { $highsize > 0 } {
				set text "<td width=\"$highsize\"><img src=\"$dmailGraphicsURL/$spacegraphichigh\" border=\"0\" width=\"$highsize\" height=\"12\" vspace=\"0\" hspace=\"0\" alt=\"Drive&nbsp;usage&nbsp;is&nbsp;at&nbsp;$thediskstatus%. Total&nbsp;drive&nbsp;space&nbsp;is&nbsp;$drivespacegig&nbsp;Gb. Actual&nbsp;space&nbsp;used&nbsp;is&nbsp;$usedspacegig&nbsp;Gb.\" ></td>"
				lappend message $text
			} 
			
			if { $remaindersize > 0 } {
				set text "<td width=\"$remaindersize\"><img src=\"$dmailGraphicsURL/$spacegraphicempty\" border=\"0\" width=\"$remaindersize\" height=\"12\" vspace=\"0\" hspace=\"0\" alt=\"Drive&nbsp;usage&nbsp;is&nbsp;at&nbsp;$thediskstatus%. Total&nbsp;drive&nbsp;space&nbsp;is&nbsp;$drivespacegig&nbsp;Gb. Actual&nbsp;space&nbsp;used&nbsp;is&nbsp;$usedspacegig&nbsp;Gb.\" ></td>"
				lappend message $text
			} 
			
			set text "<td width=\"1\"><img src=\"$dmailGraphicsURL/$spacegraphicend\" border=\"0\" width=\"1\" height=\"12\" vspace=\"0\" hspace=\"0\" alt=\"Drive&nbsp;usage&nbsp;is&nbsp;at&nbsp;$thediskstatus%. Total&nbsp;drive&nbsp;space&nbsp;is&nbsp;$drivespacegig&nbsp;Gb. Actual&nbsp;space&nbsp;used&nbsp;is&nbsp;$usedspacegig&nbsp;Gb.\" ></td>"
			lappend message $text
						
			set text "</tr></table>"
			lappend message $text
		
		}
			
		## END DISK SPACE STUFF (FROM LJ 0.2.1)
		###################################################################
		
		if {$graphicson} {
			#null
		} else {
			set text "<br><br>"
			lappend message $text
		}
				
		set text "</td></tr>"
		lappend message $text
	
	}
		

	#########################################################################################################################
	## START ENDPAD CHECKING ADDITION
	
	if { $endpadinstalled } {
		# First check the pid file and grab the process number from it
		if {$endpadstatus} {
		
			if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-Checking endpad process currency."}
			set endpadrunning ""
			set i 0
			while {$i < 5 && $endpadrunning != "ok"} {
				if { $i > 0 } {
					if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-Trying to ascertain the valid running status of the endpad daemon again - attempt [expr $i + 1]."}
					if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-Waiting for 15 seconds."}
					after 15000
				}
				if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-About to acquire pid number from endpad pid file."}
				if {[catch {
					set pidfile [open "$pidfilelocation" "r"]
					while { ! [eof $pidfile] } {
						set pidline [gets $pidfile]
						if {$pidline  != ""} {
						  set pidnumber $pidline
						} 
					}
				}]} {
					set pidnumber ""
					if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-Error gathering pid number : endpad pid file may not exist."}
				} else {
					if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-Endpad pid number gathered successfully."}
				}
				if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-pid number : >>$pidnumber<<"}
				# If we have a pid number then lets do a ps to see if the process is running	
				if {$pidnumber != ""} {
				        if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-performing ps command with pid"}
					set shellcmd "$pslocation"
					if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-the command being executed is >>exec $shellcmd $pidnumber<<."}
					if {[catch { exec $shellcmd $pidnumber } shellmsg]} {
						if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-ps command was unsuccessful."}
					} else {
						if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-ps command successful."}
				 		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-endpadexecfilename: >>$endpadexecfilename<<."}
				 		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-shellmsg (output from previous command): >>$shellmsg<<."}
				 		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-about to validate that endpad filename is present in ps command output."}
				 		if { [string first $endpadexecfilename $shellmsg] > -1 } {
				 			if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-successfully found valid endpad filename in ps output"}
							# check the endpad log stats and ensure that within a 5 minute window for valid running criteria
							if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-About to check endpad log to ensure it has been modified within the last 5 minutes."}
							if {! [catch {file stat $endpadlogloc endpadlogstats} ] } {
								if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-collected stats about endpad log file successfully."}
								if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-modification time of endpad log file : >>$endpadlogstats(mtime)<<."}
								if {[expr [clock seconds] - $endpadlogstats(mtime)] < 301 } {
									set endpadrunning "ok"
									if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-endpad daemon running ok."}
								} else {
									if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-endpad daemon not running ok - ouside 5 minute update window"}
								}
							} else {
								if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-problem - cannot collect stats about endpan log file."}
							}
						} else {
							if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-error - the valid filename is not in the ps command output"}
							if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-output of command : >>$shellmsg<<"}
						}	
					}
				}
				incr i
			}
			
			
			if {$bulletinverbose || $endpadrunning != "ok"} {
			
				if {$graphicson} {
					#null
				} else {
					set text "<br><br>"
					lappend message $text
				}	
			
   		 		if { $endpadrunning == "ok" } {
   		 			if {$graphicson} {
   		 			   	if {$dmailLinksOn} {
							set text "<tr><td width=\"80\"><center><a href=\"$dmailTivoURL/controlpadding/\"><img src=\"$dmailGraphicsURL/$endpadonfilename\" alt=\"Process&nbsp;Id:&nbsp;$pidnumber. Click&nbsp;here&nbsp;to&nbsp;start&nbsp;and&nbsp;stop&nbsp;soft&nbsp;padding.\" border=\"0\"></a></center></td><td width=\"520\""
							lappend message $text
						} else {
							set text "<tr><td width=\"80\"><center><img src=\"$dmailGraphicsURL/$endpadonfilename\" alt=\"Process&nbsp;Id:&nbsp;$pidnumber.\" border=\"0\"></center></td><td width=\"520\""
							lappend message $text					
						}
					} else {
						set text "<tr><td width=\"600\""
						lappend message $text
				        }			
					set text " class=Normal>Soft padding is active."
					lappend message $text
				} else {
   		 			if {$graphicson} {
   		 			   	if {$dmailLinksOn} {
							set text "<tr><td width=\"80\"><center><a href=\"$dmailTivoURL/controlpadding/\"><img src=\"$dmailGraphicsURL/$endpadofffilename\" border=\"0\" alt=\"Click&nbsp;here&nbsp;to&nbsp;start&nbsp;and&nbsp;stop&nbsp;soft&nbsp;padding.\" ></a></center></td><td width=\"520\""
							lappend message $text
						} else {
							set text "<tr><td width=\"80\"><center><a href=\"$dmailTivoURL/controlpadding/\"><img src=\"$dmailGraphicsURL/$endpadofffilename\" border=\"0\" alt=\"Click&nbsp;here&nbsp;to&nbsp;start&nbsp;and&nbsp;stop&nbsp;soft&nbsp;padding.\" ></a></center></td><td width=\"520\""
							lappend message $text
						}
					} else {
						set text "<tr><td width=\"600\""
						lappend message $text
				        }
					set text " class=Warning>WARNING: Soft padding is not currently active!</td></tr>"
					lappend message $text
				}
	
	
				if {$graphicson} {
					#null
				} else {
					set text "<br><br>"
					lappend message $text
				}
				
				set text "</td></tr>"
				lappend message $text
			}
		}	
	}
	
	## END ENDPAD CHECKING ADDITION
	###############################################################################################################
	
	
		

	#########################################################################################################################
	## START RED DOT CHECKING ADDITION
	
	if { $reddotinstalled } {
		# check the process
		if {$reddotstatus} {
		
			if {$graphicson} {
				#null
			} else {
				set text "<br><br>"
				lappend message $text
			}
	
			if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checking red dot process currency"}
			set reddotrunning ""
			set shellcmd "$pslocation"
			if {[catch { exec $shellcmd ax } shellmsg]} {
				# null
			} else {
			 	if { [string first $noreddotexecfilename  $shellmsg] > -1 } {
					set reddotrunning "ok"							
				} else {
					# null
				}	
			}
			
			if {$bulletinverbose || $reddotrunning!= "ok"} {
			
   		 		if { $reddotrunning == "ok" } {
   		 			if {$graphicson} {
   		 					set text "<tr><td width=\"80\"><center><img src=\"$dmailGraphicsURL/$reddotonfilename\" border=\"0\"></center></td><td width=\"520\""
							lappend message $text
					} else {
						set text "<tr><td width=\"600\""
						lappend message $text
				        }			
					set text " class=Normal>Red dot blast is active."
					lappend message $text
				} else {
   		 			if {$graphicson} {
   		 				if {$dmailLinksOn} {
							set text "<tr><td width=\"80\"><center><img src=\"$dmailGraphicsURL/$reddotofffilename\" border=\"0\" alt=\"You&nbsp;will&nbsp;need&nbsp;to&nbsp;restart&nbsp;noreddot&nbsp;at&nbsp;the&nbsp;command&nbsp;line.\" ></center></td><td width=\"520\""
							lappend message $text
						} else {
							set text "<tr><td width=\"80\"><center><img src=\"$dmailGraphicsURL/$reddotofffilename\" border=\"0\" ></center></td><td width=\"520\""
							lappend message $text					
						}
					} else {
						set text "<tr><td width=\"600\""
						lappend message $text
				        }
					set text " class=Warning>WARNING: Red dot blast is not currently active!</td></tr>"
					lappend message $text
				}
				
				if {$graphicson} {
					#null
				} else {
					set text "<br><br>"
					lappend message $text
				}
				
				set text "</td></tr>"
				lappend message $text	
			}
		}	
	}
	
	## END RED DOT CHECKING ADDITION
	###############################################################################################################
	
		
	
	#########################################################################################
	## NEW MAIL SECTION
	## only shows if there is new mail
	
		
	if { $mailcheckingon } {
	
		if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-checking for new messages in tivo central"}
	
		set gomail [checkmail]
		
		if { $gomail } {
					
			if {$graphicson} {
				if {$dmailLinksOn} {
					set text "<tr><td width=\"80\"><center><a href=\"$dmailTivoURL/listmail\"><img src=\"$dmailGraphicsURL/$mailfilename\" border=\"0\" alt=\"Click&nbsp;here&nbsp;to&nbsp;view&nbsp;new&nbsp;mails.\" ></a></center></td><td width=\"520\""
					lappend message $text
				} else {
					set text "<tr><td width=\"80\"><center><img src=\"$dmailGraphicsURL/$mailfilename\" border=\"0\" ></center></td><td width=\"520\""
					lappend message $text
				}
			} else {
				set text "<tr><td width=\"600\""
				lappend message $text
			}	
			if {$dmailLinksOn} {
				set text " class=Warning>ALERT: You have new mail (<a href=\"$dmailTivoURL/listmail\">view</a>)."
				lappend message $text
			} else {
				set text " class=Warning>ALERT: You have new mail."
			}
			

			
			set text "</td></tr>"
			lappend message $text	
		}
	}
	
	## END NEW MAIL SECTION
	##########################################################################################
	
	set text "</table>"
	lappend message $text
	
	
	if {$graphicson} {
		# null
	} else {
		set text "<br>"
		lappend message $text
	}
	
	lappend message [outputSection 1]
	lappend message [outputSection 2]
	lappend message [outputSection 3]
	lappend message [outputSection 4]
	lappend message [outputSection 5]

	if {$dmailLinksOn} {
		lappend message "<br><br>"
		lappend message "<p>visit <a href=\"$dmailTivoURL/\">my tivo</a> home page.</p>"
		lappend message "<p>click <a href=\"$dmailTivoURL/reorder/\">here</a> to re-order your season passes</p>"
		
		set twicehours [expr $originalhoursahead * 2]
		set thricehours [expr $originalhoursahead * 3]
		set fourtimeshours [expr $originalhoursahead * 4]
		set fivetimeshours [expr $originalhoursahead * 5]
		
		set oncehoursloc "$dmailTivoURL/custommail?optmsg=This+daily+e-mail+was+requested+manually+from+a+previously+sent+daily+e-mail.&recipient=$recipient&hoursahead=$originalhoursahead&submit=Send+Email"
		set twicehoursloc "$dmailTivoURL/custommail?optmsg=This+daily+e-mail+was+requested+manually+from+a+previously+sent+daily+e-mail.&recipient=$recipient&hoursahead=$twicehours&submit=Send+Email"
		set thricehoursloc "$dmailTivoURL/custommail?optmsg=This+daily+e-mail+was+requested+manually+from+a+previously+sent+daily+e-mail.&recipient=$recipient&hoursahead=$thricehours&submit=Send+Email"
		set fourtimeshoursloc "$dmailTivoURL/custommail?optmsg=This+daily+e-mail+was+requested+manually+from+a+previously+sent+daily+e-mail.&recipient=$recipient&hoursahead=$fourtimeshours&submit=Send+Email"
		set fivetimeshoursloc "$dmailTivoURL/custommail?optmsg=This+daily+e-mail+was+requested+manually+from+a+previously+sent+daily+e-mail.&recipient=$recipient&hoursahead=$fivetimeshours&submit=Send+Email"


		lappend message "<p>resend updated e-mail for <a href=\"$oncehoursloc\">$originalhoursahead</a>, <a href=\"$twicehoursloc\">$twicehours</a>, <a href=\"$thricehoursloc\">$thricehours</a>, <a href=\"$fourtimeshoursloc\">$fourtimeshours</a> or <a href=\"$fivetimeshoursloc\">$fivetimeshours</a> hours ahead.</p>"
				
	}
	
	lappend message "<br>"
	
	################################################
	## VERSION NUMBER

		lappend message "<i>jazzed dailymail v$software_version ($software_release_date) </i>"
		lappend message "<br>"
	
	##
	##################################################
	
	
	
	dbclose $db
	if {$emailsendrequired} {
		if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-e-mail required"}
		if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-about to send e-mail"}
		sendmail $mailserver $domain $recipient "TiVo status e-mail for [clock format [clock seconds] -format {%A %B %d, %Y} -gmt true]" $message
		if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-e-mail sent"}
		
		if { $recipient2 != "" } {
			if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-about to send mail to recipient 2"}
			sendmail $mailserver $domain $recipient2 "TiVo status e-mail for [clock format [clock seconds] -format {%A %B %d, %Y} -gmt true]" $message
			if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-mail sent to recipient 2"}	
		}
		
		if { $recipient3 != "" } {
			if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-about to send mail to recipient 3"}
			sendmail $mailserver $domain $recipient3 "TiVo status e-mail for [clock format [clock seconds] -format {%A %B %d, %Y} -gmt true]" $message
			if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-mail sent to recipient 3"}	
		}		
			
		
	} else {
		if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-mail not required"}
	}
	if {$htmlfilerequired} {
		if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-html file generation required"}
		if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-about to write html file"}
		writehtml $message
		if {$debuglvl>0} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-html file written"}
	} else {
		if {$debuglvl>1} { puts "[clock format [clock seconds] -format {%H:%M:%S} -gmt true]-debug-html file generation not required"}
	}

puts ""
puts "------completed the jazzed dailymail program - v$software_version ($software_release_date) - thanks for your custom"
puts "------completed at [clock format [clock seconds] -format {%H:%M:%S} -gmt true]"
puts ""
puts ""
	